import org.codehaus.groovy.grails.web.util.WebUtils
import org.springframework.web.context.request.RequestContextHolder

class ExtFormRemoteTagTests extends grails.test.GroovyPagesTestCase {

    void testExtFormRemoteWithUpdate() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" update="success" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"Ext.Ajax.request({success: function(response, options){Ext.get('success').dom.innerHTML = response.responseText;}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template
    }
    
    void testExtFormRemoteWithUpdateMap() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" update="[success: \'success\', failure: \'error\']" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"Ext.Ajax.request({success: function(response, options){Ext.get('success').dom.innerHTML = response.responseText;}, failure: function(response, options){Ext.get('error').dom.innerHTML = response.statusText;}, url: '/myapp/mycontroller/myaction/1', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template
    }

    void testExtFormRemoteWithBefore() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" before="before()" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"before();Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template
    }
    
    void testExtFormRemoteWithAfter() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" after="after()" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this});after();return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template
    }
    
    void testExtFormRemoteWithOnSuccess() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" onSuccess="success()" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"Ext.Ajax.request({success: function(response, options){success();}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template
    }
    
    void testExtFormRemoteWithOnFailure() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" onFailure="failure()" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){failure();}, url: '/myapp/mycontroller/myaction/1', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template
    }

    void testExtFormRemoteWithOnLoading() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" onLoading="loading()" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"loading();Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template
    }
    
    void testExtFormRemoteWithOnLoaded() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" onLoaded="loaded()" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"Ext.Ajax.request({success: function(response, options){loaded();}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template
    }

    void testExtFormRemoteWithOnComplete() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" onComplete="complete()" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"Ext.Ajax.request({success: function(response, options){complete();}, failure: function(response, options){complete();}, url: '/myapp/mycontroller/myaction/1', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template
    }
    
    void testExtFormRemoteWithAllOnEvents() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"loading();Ext.Ajax.request({success: function(response, options){loaded();success();complete();}, failure: function(response, options){failure();complete();}, url: '/myapp/mycontroller/myaction/1', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template
    }

    void testExtFormRemoteWithAllOnEventsAndUpdate() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" update="success" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"loading();Ext.Ajax.request({success: function(response, options){loaded();Ext.get('success').dom.innerHTML = response.responseText;success();complete();}, failure: function(response, options){failure();complete();}, url: '/myapp/mycontroller/myaction/1', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template
    }
    
    void testExtFormRemoteWithAllOnEventsAndUpdateMap() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" update="[success: \'success\', failure: \'error\']" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"loading();Ext.Ajax.request({success: function(response, options){loaded();Ext.get('success').dom.innerHTML = response.responseText;success();complete();}, failure: function(response, options){Ext.get('error').dom.innerHTML = response.statusText;failure();complete();}, url: '/myapp/mycontroller/myaction/1', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template
    }

    void testExtFormRemoteWithClassAttribute() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" class="myclass" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" class=\"myclass\" name=\"myform\" id=\"myform\"></form>", template
    }
    
    void testExtFormRemoteGetWithoutParams() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" method="GET" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"Ext.Ajax.request({method: 'GET', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template
    }

    void testExtFormRemoteGetWithSingleParam() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" method="GET" params="[var1: \'one\']" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"Ext.Ajax.request({method: 'GET', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template
    }    
    
    void testExtFormRemoteGetWithMultipleParams() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" method="GET" params="[var1: \'one\', var2: \'two\']" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"Ext.Ajax.request({method: 'GET', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one&var2=two', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template
    }
    
    void testExtFormRemotePostWithoutParams() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" method="POST" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"Ext.Ajax.request({method: 'POST', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template
    }
    
    void testExtFormRemotePostWithSingleParam() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" method="POST" params="[var1: \'one\']" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"Ext.Ajax.request({method: 'POST', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template
    }
    
    void testExtFormRemotePostWithMultipleParams() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" method="POST" params="[var1: \'one\', var2: \'two\']" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"Ext.Ajax.request({method: 'POST', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one&var2=two', form: this});return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" name=\"myform\" id=\"myform\"></form>", template        
    }
    
    void testExtFormRemoteGetWithEverything() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" method="GET" params="[var1: \'one\', var2: \'two\']" before="before()" after="after()" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" update="[success: \'success\', failure: \'error\']" class="myclass" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"before();loading();Ext.Ajax.request({method: 'GET', success: function(response, options){loaded();Ext.get('success').dom.innerHTML = response.responseText;success();complete();}, failure: function(response, options){Ext.get('error').dom.innerHTML = response.statusText;failure();complete();}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one&var2=two', form: this});after();return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" class=\"myclass\" name=\"myform\" id=\"myform\"></form>", template
    }

    void testExtFormRemotePostWithEverything() {
        def template = '<g:formRemote url="[controller: \'mycontroller\', action: \'myaction\', id: 1]" method="POST" params="[var1: \'one\', var2: \'two\']" before="before()" after="after()" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" update="[success: \'success\', failure: \'error\']" class="myclass" name="myform"/>'
        assertOutputEquals "<form onsubmit=\"before();loading();Ext.Ajax.request({method: 'POST', success: function(response, options){loaded();Ext.get('success').dom.innerHTML = response.responseText;success();complete();}, failure: function(response, options){Ext.get('error').dom.innerHTML = response.statusText;failure();complete();}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one&var2=two', form: this});after();return false\" method=\"POST\" action=\"/myapp/mycontroller/myaction/1\" class=\"myclass\" name=\"myform\" id=\"myform\"></form>", template
    }
    
    void setUp() {
        RequestContextHolder.currentRequestAttributes().currentRequest."${WebUtils.INCLUDE_CONTEXT_PATH_ATTRIBUTE}" = '/myapp'
        RequestContextHolder.currentRequestAttributes().currentRequest."org.codehaus.grails.INCLUDED_JS_LIBRARIES" = ['ext']
    }
}
