import org.codehaus.groovy.grails.web.util.WebUtils
import org.springframework.web.context.request.RequestContextHolder

class ExtSubmitToRemoteTagTests extends grails.test.GroovyPagesTestCase {

    void testExtSubmitToRemoteWithUpdate() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" update="success" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"Ext.Ajax.request({success: function(response, options){Ext.get('success').dom.innerHTML = response.responseText;}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }
    
    void testExtSubmitToRemoteWithUpdateMap() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" update="[success: \'success\', failure: \'error\']" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"Ext.Ajax.request({success: function(response, options){Ext.get('success').dom.innerHTML = response.responseText;}, failure: function(response, options){Ext.get('error').dom.innerHTML = response.statusText;}, url: '/myapp/mycontroller/myaction/1', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }

    void testExtSubmitToRemoteWithBefore() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" before="before()" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"before();Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }
    
    void testExtSubmitToRemoteWithAfter() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" after="after()" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this.form});after();return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }
    
    void testExtSubmitToRemoteWithOnSuccess() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" onSuccess="success()" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"Ext.Ajax.request({success: function(response, options){success();}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }
    
    void testExtSubmitToRemoteWithOnFailure() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" onFailure="failure()" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){failure();}, url: '/myapp/mycontroller/myaction/1', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }

    void testExtSubmitToRemoteWithOnLoading() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" onLoading="loading()" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"loading();Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }
    
    void testExtSubmitToRemoteWithOnLoaded() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" onLoaded="loaded()" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"Ext.Ajax.request({success: function(response, options){loaded();}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }

    void testExtSubmitToRemoteWithOnComplete() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" onComplete="complete()" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"Ext.Ajax.request({success: function(response, options){complete();}, failure: function(response, options){complete();}, url: '/myapp/mycontroller/myaction/1', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }
    
    void testExtSubmitToRemoteWithAllOnEvents() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"loading();Ext.Ajax.request({success: function(response, options){loaded();success();complete();}, failure: function(response, options){failure();complete();}, url: '/myapp/mycontroller/myaction/1', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }

    void testExtSubmitToRemoteWithAllOnEventsAndUpdate() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" update="success" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"loading();Ext.Ajax.request({success: function(response, options){loaded();Ext.get('success').dom.innerHTML = response.responseText;success();complete();}, failure: function(response, options){failure();complete();}, url: '/myapp/mycontroller/myaction/1', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }
    
    void testExtSubmitToRemoteWithAllOnEventsAndUpdateMap() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" update="[success: \'success\', failure: \'error\']" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"loading();Ext.Ajax.request({success: function(response, options){loaded();Ext.get('success').dom.innerHTML = response.responseText;success();complete();}, failure: function(response, options){Ext.get('error').dom.innerHTML = response.statusText;failure();complete();}, url: '/myapp/mycontroller/myaction/1', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }

    void testExtSubmitToRemoteWithClassAttribute() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" class="myclass" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\" class=\"myclass\"></input>", template
    }
    
    void testExtSubmitToRemoteGetWithoutParams() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" method="GET" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"Ext.Ajax.request({method: 'GET', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }

    void testExtSubmitToRemoteGetWithSingleParam() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" method="GET" params="[var1: \'one\']" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"Ext.Ajax.request({method: 'GET', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }
    
    void testExtSubmitToRemoteGetWithMultipleParams() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" method="GET" params="[var1: \'one\', var2: \'two\']" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"Ext.Ajax.request({method: 'GET', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one&var2=two', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }
    
    void testExtSubmitToRemotePostWithoutParams() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" method="POST" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"Ext.Ajax.request({method: 'POST', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }

    void testExtSubmitToRemotePostWithSingleParam() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" method="POST" params="[var1: \'one\']" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"Ext.Ajax.request({method: 'POST', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }
    
    void testExtSubmitToRemotePostWithMultipleParams() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" method="POST" params="[var1: \'one\', var2: \'two\']" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"Ext.Ajax.request({method: 'POST', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one&var2=two', form: this.form});return false\" type=\"button\" name=\"myname\" value=\"myvalue\"></input>", template
    }
    
    void testExtSubmitToRemoteGetWithEverything() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" method="GET" params="[var1: \'one\', var2: \'two\']" before="before()" after="after()" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" update="[success: \'success\', failure: \'error\']" class="myclass" paramName="myparam" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"before();loading();Ext.Ajax.request({method: 'GET', success: function(response, options){loaded();Ext.get('success').dom.innerHTML = response.responseText;success();complete();}, failure: function(response, options){Ext.get('error').dom.innerHTML = response.statusText;failure();complete();}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one&var2=two', form: this.form});after();return false\" type=\"button\" name=\"myname\" value=\"myvalue\" class=\"myclass\"></input>", template
    }

    void testExtSubmitToRemotePostWithEverything() {
        def template = '<g:submitToRemote controller="mycontroller" action="myaction" id="1" method="POST" params="[var1: \'one\', var2: \'two\']" before="before()" after="after()" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" update="[success: \'success\', failure: \'error\']" class="myclass" paramName="myparam" name="myname" value="myvalue"/>'
        assertOutputEquals "<input onclick=\"before();loading();Ext.Ajax.request({method: 'POST', success: function(response, options){loaded();Ext.get('success').dom.innerHTML = response.responseText;success();complete();}, failure: function(response, options){Ext.get('error').dom.innerHTML = response.statusText;failure();complete();}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one&var2=two', form: this.form});after();return false\" type=\"button\" name=\"myname\" value=\"myvalue\" class=\"myclass\"></input>", template
    }
    
    void setUp() {
        RequestContextHolder.currentRequestAttributes().currentRequest."${WebUtils.INCLUDE_CONTEXT_PATH_ATTRIBUTE}" = '/myapp'
        RequestContextHolder.currentRequestAttributes().currentRequest."org.codehaus.grails.INCLUDED_JS_LIBRARIES" = ['ext']
    }
}
