import org.codehaus.groovy.grails.web.util.WebUtils
import org.springframework.web.context.request.RequestContextHolder

class ExtRemoteFieldTagTests extends grails.test.GroovyPagesTestCase {

    void testExtRemoteFieldWithUpdate() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" update="success" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"Ext.Ajax.request({success: function(response, options){Ext.get('success').dom.innerHTML = response.responseText;}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value});\" />", template
    }
    
    void testExtRemoteFieldWithUpdateMap() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" update="[success: \'success\', failure: \'error\']" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"Ext.Ajax.request({success: function(response, options){Ext.get('success').dom.innerHTML = response.responseText;}, failure: function(response, options){Ext.get('error').dom.innerHTML = response.statusText;}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value});\" />", template
    }

    void testExtRemoteFieldWithBefore() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" before="before()" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"before();Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value});\" />", template
    }
    
    void testExtRemoteFieldWithAfter() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" after="after()" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value});after();\" />", template
    }
    
    void testExtRemoteFieldWithOnSuccess() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" onSuccess="success()" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"Ext.Ajax.request({success: function(response, options){success();}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value});\" />", template
    }
    
    void testExtRemoteFieldWithOnFailure() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" onFailure="failure()" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){failure();}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value});\" />", template
    }

    void testExtRemoteFieldWithOnLoading() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" onLoading="loading()" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"loading();Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value});\" />", template
    }
    
    void testExtRemoteFieldWithOnLoaded() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" onLoaded="loaded()" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"Ext.Ajax.request({success: function(response, options){loaded();}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value});\" />", template
    }

    void testExtRemoteFieldWithOnComplete() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" onComplete="complete()" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"Ext.Ajax.request({success: function(response, options){complete();}, failure: function(response, options){complete();}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value});\" />", template
    }
    
    void testExtRemoteFieldWithAllOnEvents() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"loading();Ext.Ajax.request({success: function(response, options){loaded();success();complete();}, failure: function(response, options){failure();complete();}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value});\" />", template
    }

    void testExtRemoteFieldWithAllOnEventsAndUpdate() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" update="success" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"loading();Ext.Ajax.request({success: function(response, options){loaded();Ext.get('success').dom.innerHTML = response.responseText;success();complete();}, failure: function(response, options){failure();complete();}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value});\" />", template
    }
    
    void testExtRemoteFieldWithAllOnEventsAndUpdateMap() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" update="[success: \'success\', failure: \'error\']" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"loading();Ext.Ajax.request({success: function(response, options){loaded();Ext.get('success').dom.innerHTML = response.responseText;success();complete();}, failure: function(response, options){Ext.get('error').dom.innerHTML = response.statusText;failure();complete();}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value});\" />", template
    }

    void testExtRemoteFieldWithClassAttribute() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" class="myclass" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value});\" class=\"myclass\" />", template
    }
    
    void testExtRemoteFieldGetWithoutParams() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" method="GET" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"Ext.Ajax.request({method: 'GET', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value});\" />", template
    }

    void testExtRemoteFieldGetWithSingleParam() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" method="GET" params="[var1: \'one\']" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"Ext.Ajax.request({method: 'GET', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value+'&var1=one'});\" />", template
    }
    
    void testExtRemoteFieldGetWithMultipleParams() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" method="GET" params="[var1: \'one\', var2: \'two\']" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"Ext.Ajax.request({method: 'GET', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value+'&var1=one&var2=two'});\" />", template
    }
    
    void testExtRemoteFieldPostWithoutParams() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" method="POST" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"Ext.Ajax.request({method: 'POST', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value});\" />", template
    }

    void testExtRemoteFieldPostWithSingleParam() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" method="POST" params="[var1: \'one\']" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"Ext.Ajax.request({method: 'POST', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value+'&var1=one'});\" />", template
    }
    
    void testExtRemoteFieldPostWithMultipleParams() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" method="POST" params="[var1: \'one\', var2: \'two\']" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"Ext.Ajax.request({method: 'POST', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'value='+this.value+'&var1=one&var2=two'});\" />", template
    }
    
    void testExtRemoteFieldGetWithEverything() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" method="GET" params="[var1: \'one\', var2: \'two\']" before="before()" after="after()" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" update="[success: \'success\', failure: \'error\']" class="myclass" paramName="myparam" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"before();loading();Ext.Ajax.request({method: 'GET', success: function(response, options){loaded();Ext.get('success').dom.innerHTML = response.responseText;success();complete();}, failure: function(response, options){Ext.get('error').dom.innerHTML = response.statusText;failure();complete();}, url: '/myapp/mycontroller/myaction/1', params: 'myparam='+this.value+'&var1=one&var2=two'});after();\" class=\"myclass\" />", template
    }

    void testExtRemoteFieldPostWithEverything() {
        def template = '<g:remoteField controller="mycontroller" action="myaction" id="1" method="POST" params="[var1: \'one\', var2: \'two\']" before="before()" after="after()" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" update="[success: \'success\', failure: \'error\']" class="myclass" paramName="myparam" name="myname" value="myvalue"/>'
        assertOutputEquals "<input type=\"text\" name=\"myname\" value=\"myvalue\" onkeyup=\"before();loading();Ext.Ajax.request({method: 'POST', success: function(response, options){loaded();Ext.get('success').dom.innerHTML = response.responseText;success();complete();}, failure: function(response, options){Ext.get('error').dom.innerHTML = response.statusText;failure();complete();}, url: '/myapp/mycontroller/myaction/1', params: 'myparam='+this.value+'&var1=one&var2=two'});after();\" class=\"myclass\" />", template
    }
    
    void setUp() {
        RequestContextHolder.currentRequestAttributes().currentRequest."${WebUtils.INCLUDE_CONTEXT_PATH_ATTRIBUTE}" = '/myapp'
        RequestContextHolder.currentRequestAttributes().currentRequest."org.codehaus.grails.INCLUDED_JS_LIBRARIES" = ['ext']
    }
}
