import org.codehaus.groovy.grails.web.util.WebUtils
import org.springframework.web.context.request.RequestContextHolder

class ExtRemoteLinkTagTests extends grails.test.GroovyPagesTestCase {
    
    void testExtRemoteLinkWithUpdate() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" update="success">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1\" onclick=\"Ext.Ajax.request({success: function(response, options){Ext.get('success').dom.innerHTML = response.responseText;}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1'});return false;\">My Action</a>", template
    }
    
    void testExtRemoteLinkWithUpdateMap() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" update="[success: \'success\', failure: \'error\']">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1\" onclick=\"Ext.Ajax.request({success: function(response, options){Ext.get('success').dom.innerHTML = response.responseText;}, failure: function(response, options){Ext.get('error').dom.innerHTML = response.statusText;}, url: '/myapp/mycontroller/myaction/1'});return false;\">My Action</a>", template
    }

    void testExtRemoteLinkWithBefore() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" before="before()">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1\" onclick=\"before();Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1'});return false;\">My Action</a>", template
    }
    
    void testExtRemoteLinkWithAfter() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" after="after()">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1\" onclick=\"Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1'});after();return false;\">My Action</a>", template
    }
    
    void testExtRemoteLinkWithOnSuccess() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" onSuccess="success()">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1\" onclick=\"Ext.Ajax.request({success: function(response, options){success();}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1'});return false;\">My Action</a>", template
    }
    
    void testExtRemoteLinkWithOnFailure() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" onFailure="failure()">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1\" onclick=\"Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){failure();}, url: '/myapp/mycontroller/myaction/1'});return false;\">My Action</a>", template
    }

    void testExtRemoteLinkWithOnLoading() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" onLoading="loading()">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1\" onclick=\"loading();Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1'});return false;\">My Action</a>", template
    }
    
    void testExtRemoteLinkWithOnLoaded() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" onLoaded="loaded()">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1\" onclick=\"Ext.Ajax.request({success: function(response, options){loaded();}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1'});return false;\">My Action</a>", template
    }

    void testExtRemoteLinkWithOnComplete() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" onComplete="complete()">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1\" onclick=\"Ext.Ajax.request({success: function(response, options){complete();}, failure: function(response, options){complete();}, url: '/myapp/mycontroller/myaction/1'});return false;\">My Action</a>", template
    }
    
    void testExtRemoteLinkWithAllOnEvents() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1\" onclick=\"loading();Ext.Ajax.request({success: function(response, options){loaded();success();complete();}, failure: function(response, options){failure();complete();}, url: '/myapp/mycontroller/myaction/1'});return false;\">My Action</a>", template
    }

    void testExtRemoteLinkWithAllOnEventsAndUpdate() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" update="success">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1\" onclick=\"loading();Ext.Ajax.request({success: function(response, options){loaded();Ext.get('success').dom.innerHTML = response.responseText;success();complete();}, failure: function(response, options){failure();complete();}, url: '/myapp/mycontroller/myaction/1'});return false;\">My Action</a>", template
    }
    
    void testExtRemoteLinkWithAllOnEventsAndUpdateMap() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" update="[success: \'success\', failure: \'error\']">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1\" onclick=\"loading();Ext.Ajax.request({success: function(response, options){loaded();Ext.get('success').dom.innerHTML = response.responseText;success();complete();}, failure: function(response, options){Ext.get('error').dom.innerHTML = response.statusText;failure();complete();}, url: '/myapp/mycontroller/myaction/1'});return false;\">My Action</a>", template
    }

    void testExtRemoteLinkWithClassAttribute() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" class="myclass">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1\" onclick=\"Ext.Ajax.request({success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1'});return false;\" class=\"myclass\">My Action</a>", template
    }
    
    void testExtRemoteLinkGetWithoutParams() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" method="GET">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1\" onclick=\"Ext.Ajax.request({method: 'GET', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1'});return false;\">My Action</a>", template
    }

    void testExtRemoteLinkGetWithSingleParam() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" method="GET" params="[var1: \'one\']">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1?var1=one\" onclick=\"Ext.Ajax.request({method: 'GET', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one'});return false;\">My Action</a>", template
    }
    
    void testExtRemoteLinkGetWithMultipleParams() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" method="GET" params="[var1: \'one\', var2: \'two\']">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1?var1=one&var2=two\" onclick=\"Ext.Ajax.request({method: 'GET', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one&var2=two'});return false;\">My Action</a>", template
    }
    
    void testExtRemoteLinkPostWithoutParams() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" method="POST">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1\" onclick=\"Ext.Ajax.request({method: 'POST', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1'});return false;\">My Action</a>", template
    }

    void testExtRemoteLinkPostWithSingleParam() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" method="POST" params="[var1: \'one\']">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1?var1=one\" onclick=\"Ext.Ajax.request({method: 'POST', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one'});return false;\">My Action</a>", template
    }
    
    void testExtRemoteLinkPostWithMultipleParams() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" method="POST" params="[var1: \'one\', var2: \'two\']">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1?var1=one&var2=two\" onclick=\"Ext.Ajax.request({method: 'POST', success: function(response, options){}, failure: function(response, options){}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one&var2=two'});return false;\">My Action</a>", template
    }
    
    void testExtRemoteLinkGetWithEverything() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" method="GET" params="[var1: \'one\', var2: \'two\']" before="before()" after="after()" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" update="[success: \'success\', failure: \'error\']" class="myclass">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1?var1=one&var2=two\" onclick=\"before();loading();Ext.Ajax.request({method: 'GET', success: function(response, options){loaded();Ext.get('success').dom.innerHTML = response.responseText;success();complete();}, failure: function(response, options){Ext.get('error').dom.innerHTML = response.statusText;failure();complete();}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one&var2=two'});after();return false;\" class=\"myclass\">My Action</a>", template
    }
    
    void testExtRemoteLinkPostWithEverything() {
        def template = '<g:remoteLink controller="mycontroller" action="myaction" id="1" method="POST" params="[var1: \'one\', var2: \'two\']" before="before()" after="after()" onSuccess="success()" onFailure="failure()" onLoading="loading()" onLoaded="loaded()" onComplete="complete()" update="[success: \'success\', failure: \'error\']" class="myclass">My Action</g:remoteLink>'
        assertOutputEquals "<a href=\"/myapp/mycontroller/myaction/1?var1=one&var2=two\" onclick=\"before();loading();Ext.Ajax.request({method: 'POST', success: function(response, options){loaded();Ext.get('success').dom.innerHTML = response.responseText;success();complete();}, failure: function(response, options){Ext.get('error').dom.innerHTML = response.statusText;failure();complete();}, url: '/myapp/mycontroller/myaction/1', params: 'var1=one&var2=two'});after();return false;\" class=\"myclass\">My Action</a>", template
    }
    
    void setUp() {
        RequestContextHolder.currentRequestAttributes().currentRequest."${WebUtils.INCLUDE_CONTEXT_PATH_ATTRIBUTE}" = '/myapp'
        RequestContextHolder.currentRequestAttributes().currentRequest."org.codehaus.grails.INCLUDED_JS_LIBRARIES" = ['ext']
    }
}
