import org.codehaus.groovy.grails.plugins.ext.Ext
import org.codehaus.groovy.grails.web.util.WebUtils
import org.springframework.web.context.request.RequestContextHolder

class ExtTagLibTests extends grails.test.GroovyPagesTestCase {

    void testExtJavascriptTag() {
        def template = '<ext:javascript dir="build/widgets" file="DatePicker-min.js" />' 
        assertOutputEquals "<script type=\"text/javascript\" src=\"/myapp/js/ext/${Ext.version}/build/widgets/DatePicker-min.js\"></script>", template
    }

    void testExtJavascriptTagWithVersion() {
        def template = '<ext:javascript dir="build/widgets" file="DatePicker-min.js" version="2.0.1" />' 
        assertOutputEquals "<script type=\"text/javascript\" src=\"/myapp/js/ext/2.0.1/build/widgets/DatePicker-min.js\"></script>", template
    }

    void testExtJavascriptTagWithoutDir() {
        def template = '<ext:javascript file="ext-all.js" />' 
        assertOutputEquals "<script type=\"text/javascript\" src=\"/myapp/js/ext/${Ext.version}/ext-all.js\"></script>", template
    }
    
    void testExtStylesheetTag() {
        def template = '<ext:stylesheet dir="resources/css" file="date-picker.css" />' 
        assertOutputEquals "<link rel=\"stylesheet\" type=\"text/css\" href=\"/myapp/js/ext/${Ext.version}/resources/css/date-picker.css\" />", template
    }

    void testExtStylesheetTagWithVersion() {
        def template = '<ext:stylesheet dir="resources/css" file="date-picker.css" version="2.0.1" />' 
        assertOutputEquals "<link rel=\"stylesheet\" type=\"text/css\" href=\"/myapp/js/ext/2.0.1/resources/css/date-picker.css\" />", template
    }
    
    void setUp() {
        RequestContextHolder.currentRequestAttributes().currentRequest."${WebUtils.INCLUDE_CONTEXT_PATH_ATTRIBUTE}" = '/myapp'        
    }
}
