class ScoutingReport {
    static belongsTo = [User]
    static hasMany = [scoutingNotes:ScoutingNotes]
    
    static constraints = {
        generalNotes (nullable:true)
        strengths (nullable:true)
        weaknesses (nullable:true)
        tendencies (nullable:true)
    }
    
    Player player
    User scout
    
    String generalNotes
    String strengths
    String weaknesses
    String tendencies
    
    BigDecimal ratingSkating = 0.0
    BigDecimal ratingPuckControl = 0.0
    BigDecimal ratingPhysicalPlay = 0.0
    BigDecimal ratingSize = 0.0
    BigDecimal ratingHockeySense = 0.0
    BigDecimal ratingIntensity = 0.0
    BigDecimal ratingOffensivePlay = 0.0
    BigDecimal ratingDefensivePlay =0.0
    
    public def getOverallRating() {
        def skating = ratingSkating ? ratingSkating : 0.0
        def puckControl = ratingPuckControl ? ratingPuckControl : 0.0
        def physicalPlay = ratingPhysicalPlay ? ratingPhysicalPlay : 0.0
        def sizeRating = ratingSize ? ratingSize : 0.0
        def hockeySense = ratingHockeySense ? ratingHockeySense : 0.0
        def intensity = ratingIntensity ? ratingIntensity : 0.0
        def offensivePlay = ratingOffensivePlay ? ratingOffensivePlay : 0.0
        def defensivePlay = ratingDefensivePlay ? ratingDefensivePlay : 0.0   
                
        return (skating + puckControl + physicalPlay + sizeRating + hockeySense + intensity + offensivePlay + defensivePlay) / 8
    }
    
}
