

<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
        <meta name="layout" content="main" />
        <title>Edit Player</title>
    </head>
    <body>
        <div class="nav">
            <span class="menuButton"><a class="home" href="${createLinkTo(dir:'')}">Home</a></span>
            <span class="menuButton"><g:link class="list" action="list">Player List</g:link></span>
            <span class="menuButton"><g:link class="create" action="create">New Player</g:link></span>
        </div>
        <div class="body">
            <h1>Edit Player</h1>
            <g:if test="${flash.message}">
            <div class="message">${flash.message}</div>
            </g:if>
            <g:hasErrors bean="${playerInstance}">
            <div class="errors">
                <g:renderErrors bean="${playerInstance}" as="list" />
            </div>
            </g:hasErrors>
            <g:form method="post" >
                <input type="hidden" name="id" value="${playerInstance?.id}" />
                <input type="hidden" name="version" value="${playerInstance?.version}" />
                <div class="dialog">
                    <table>
                        <tbody>
                        
                            <tr class="prop">
                                <td valign="top" class="name">
                                    <label for="heightFeet">Height Feet:</label>
                                </td>
                                <td valign="top" class="value ${hasErrors(bean:playerInstance,field:'heightFeet','errors')}">
                                    <input type="text" id="heightFeet" name="heightFeet" value="${fieldValue(bean:playerInstance,field:'heightFeet')}" />
                                </td>
                            </tr> 
                        
                            <tr class="prop">
                                <td valign="top" class="name">
                                    <label for="heightInches">Height Inches:</label>
                                </td>
                                <td valign="top" class="value ${hasErrors(bean:playerInstance,field:'heightInches','errors')}">
                                    <input type="text" id="heightInches" name="heightInches" value="${fieldValue(bean:playerInstance,field:'heightInches')}" />
                                </td>
                            </tr> 
                        
                            <tr class="prop">
                                <td valign="top" class="name">
                                    <label for="weightInPounds">Weight In Pounds:</label>
                                </td>
                                <td valign="top" class="value ${hasErrors(bean:playerInstance,field:'weightInPounds','errors')}">
                                    <input type="text" id="weightInPounds" name="weightInPounds" value="${fieldValue(bean:playerInstance,field:'weightInPounds')}" />
                                </td>
                            </tr> 
                        
                            <tr class="prop">
                                <td valign="top" class="name">
                                    <label for="firstName">First Name:</label>
                                </td>
                                <td valign="top" class="value ${hasErrors(bean:playerInstance,field:'firstName','errors')}">
                                    <input type="text" id="firstName" name="firstName" value="${fieldValue(bean:playerInstance,field:'firstName')}"/>
                                </td>
                            </tr> 
                        
                            <tr class="prop">
                                <td valign="top" class="name">
                                    <label for="gameStats">Game Stats:</label>
                                </td>
                                <td valign="top" class="value ${hasErrors(bean:playerInstance,field:'gameStats','errors')}">
                                    
<ul>
<g:each var="g" in="${playerInstance?.gameStats?}">
    <li><g:link controller="playerStats" action="show" id="${g.id}">${g?.encodeAsHTML()}</g:link></li>
</g:each>
</ul>
<g:link controller="playerStats" params="['player.id':playerInstance?.id]" action="create">Add PlayerStats</g:link>

                                </td>
                            </tr> 
                        
                            <tr class="prop">
                                <td valign="top" class="name">
                                    <label for="lastName">Last Name:</label>
                                </td>
                                <td valign="top" class="value ${hasErrors(bean:playerInstance,field:'lastName','errors')}">
                                    <input type="text" id="lastName" name="lastName" value="${fieldValue(bean:playerInstance,field:'lastName')}"/>
                                </td>
                            </tr> 
                        
                            <tr class="prop">
                                <td valign="top" class="name">
                                    <label for="newsItems">News Items:</label>
                                </td>
                                <td valign="top" class="value ${hasErrors(bean:playerInstance,field:'newsItems','errors')}">
                                    
<ul>
<g:each var="n" in="${playerInstance?.newsItems?}">
    <li><g:link controller="playerNews" action="show" id="${n.id}">${n?.encodeAsHTML()}</g:link></li>
</g:each>
</ul>
<g:link controller="playerNews" params="['player.id':playerInstance?.id]" action="create">Add PlayerNews</g:link>

                                </td>
                            </tr> 
                        
                            <tr class="prop">
                                <td valign="top" class="name">
                                    <label for="number">Number:</label>
                                </td>
                                <td valign="top" class="value ${hasErrors(bean:playerInstance,field:'number','errors')}">
                                    <input type="text" id="number" name="number" value="${fieldValue(bean:playerInstance,field:'number')}" />
                                </td>
                            </tr> 
                        
                            <tr class="prop">
                                <td valign="top" class="name">
                                    <label for="scoutingReports">Scouting Reports:</label>
                                </td>
                                <td valign="top" class="value ${hasErrors(bean:playerInstance,field:'scoutingReports','errors')}">
                                    
<ul>
<g:each var="s" in="${playerInstance?.scoutingReports?}">
    <li><g:link controller="scoutingReport" action="show" id="${s.id}">${s?.encodeAsHTML()}</g:link></li>
</g:each>
</ul>
<g:link controller="scoutingReport" params="['player.id':playerInstance?.id]" action="create">Add ScoutingReport</g:link>

                                </td>
                            </tr> 
                        
                            <tr class="prop">
                                <td valign="top" class="name">
                                    <label for="team">Team:</label>
                                </td>
                                <td valign="top" class="value ${hasErrors(bean:playerInstance,field:'team','errors')}">
                                    <g:select optionKey="id" from="${Team.list()}" name="team.id" value="${playerInstance?.team?.id}" ></g:select>
                                </td>
                            </tr> 
                        
                        </tbody>
                    </table>
                </div>
                <div class="buttons">
                    <span class="button"><g:actionSubmit class="save" value="Update" /></span>
                    <span class="button"><g:actionSubmit class="delete" onclick="return confirm('Are you sure?');" value="Delete" /></span>
                </div>
            </g:form>
        </div>
    </body>
</html>
