class GameTests extends GroovyTestCase {

    void testNewGameToSeason() {
        League nhl = TestDataCreator.createNHL()
        Team homeTeam = TestDataCreator.createTeamMnWild()
        Team visitingTeam = TestDataCreator.createTeamNJDevils()
        Season season = TestDataCreator.createSeason(2008, 2009)
        Game newGame = TestDataCreator.createGame()
        
        // Setup the league
        nhl.addToTeams(homeTeam)
        nhl.addToTeams(visitingTeam)
        nhl.addToSeasons(season)
        nhl.save(flush:true)
        
        // Setup and save the game
        newGame.season = season
        newGame.homeTeam = homeTeam
        newGame.visitorTeam = visitingTeam
        
        newGame.save(flush:true)
        
        assertEquals 1, Game.list().size()
    }
}
