import java.text.SimpleDateFormat
class LeagueControllerTests extends GroovyTestCase {

    void testLeagueListJSON() {
        def leagueController = new LeagueController();
        def nhl = TestDataCreator.createNHL()
        
        nhl.save(flush:true)
        
        leagueController.showREST();
        
        println(leagueController.response.contentAsString)
    }
    
    void testSaveNewLeague() {
        def leagueController = new LeagueController();
        
        leagueController.params.id = ''
        leagueController.params.name = 'WHL'
        leagueController.params.description = 'Western Hockey League'
        leagueController.params.sinceDate = new SimpleDateFormat('yyyy-MM-dd').parse('1925-09-01')
        
        leagueController.saveREST();
        
        println(leagueController.response.contentAsString)
        
    }
    
    void testSaveExistingLeague() {
        def leagueController = new LeagueController();
        def nhl = TestDataCreator.createNHL()
        
        nhl.save(flush:true)
        
        leagueController.params.id = nhl.id
        leagueController.params.description = 'League de Nationale'
        
        leagueController.saveREST();
        
        println(leagueController.response.contentAsString)
    }
    
}
