import java.util.Calendar
import java.util.GregorianCalendar
class LeagueTests extends GroovyTestCase {

    void testNewLeague() {       
        def nhl = TestDataCreator.createNHL()
        
        nhl.save(flush:true)
        if (nhl.errors) {
            nhl.errors.each {println it}
        }
        
        for (league in League.list()) {
            println league.id + ": " + league.name
        }
        assertEquals 1, League.list().size()
    }
    
    void testLeagueAddingTeams() {
        def nhl = TestDataCreator.createNHL()
        
        nhl.addToTeams(new Team(name: 'Minnesota Wild', playsIn: 'Saint Paul, MN', playsInArena: "Excel Center"))
        nhl.addToTeams(new Team(name: 'New Jersey Devils', playsIn: 'Newark, NJ', playsInArena: "Prudential Center"))
        
        nhl.save(flush:true)
        
        def teamList = Team.list()
        
        assertNotNull teamList
        assertEquals 2, teamList.size()
    }
    
    void testLeagueAddingSeasons() {
        def nhl = TestDataCreator.createNHL()
        Date seasonStart = new GregorianCalendar(2008, Calendar.SEPTEMBER, 01).time
        Date seasonEnd = new GregorianCalendar(2009, Calendar.JUNE, 30).time

        
        nhl.addToSeasons(new Season(fromDate:seasonStart, toDate:seasonEnd))
        
        nhl.save(flush:true)
        
        def seasonList = Season.list()
        
        assertNotNull seasonList
        assertEquals 1, seasonList.size()
    }
}
