class ScoutingReportControllerTests extends GroovyTestCase {

    void testScoutingReportListJSON() {
        def controller = new ScoutingReportController()
        
        initTestData()

        // Test getting a list of reports
        controller.showREST();
        println(controller.response.contentAsString)
    }
    
    void testScoutingReportByIdJSON() {
        def controller = new ScoutingReportController()
        
        initTestData()
        
        // Test getting a list of reports
        def reports = ScoutingReport.list()
        
        controller.params.id = reports[0].id
        controller.showREST()
        println(controller.response.contentAsString)
    }
    
    void testSaveScoutingReportJSON() {
        def controller = new ScoutingReportController()
        
        initTestData()
        
        // Test getting a list of reports
        controller.params.playerId = String.valueOf(Player.findByLastName("Elias").id)
        controller.params.userId = User.findByUsername("tlomenda").id
        controller.saveREST()
        
        // Perform assertions
        def reports = ScoutingReport.list()
        
        assertEquals 3, reports.size()
        println(controller.response.contentAsString)
    }
    
    private void initTestData() {
        User user = new User(username: 'tlomenda', password: 'password', email:'xx@xx.com', passwd: 'password', userRealName: 'El Chapo')
        League nhl = TestDataCreator.createNHL()
        Team mnWild = TestDataCreator.createTeamMnWild()
        Player gaborik = TestDataCreator.createMarianGaborik()
        Player elias = TestDataCreator.createPatrikElias()
        Player crosby = TestDataCreator.createSidneyCrosby()
        
        user.save()
        
        nhl.addToTeams(mnWild)
        nhl.save()
        
        // Save the player with stats
        gaborik.team = mnWild
        gaborik.save()
        crosby.team = mnWild
        crosby.save()
        elias.team = mnWild
        elias.save()
        
        // Create a new report
        ScoutingReport report = TestDataCreator.createScoutingReport(user, gaborik)
        report.save(flush:true)
        
        report = TestDataCreator.createScoutingReport(user, crosby)
        report.save(flush:true)
    }
}
