class TeamTests extends GroovyTestCase {

    void testNewTeam() {
        League nhl = TestDataCreator.createNHL()
        Team newTeam = TestDataCreator.createTeamMnWild()
        
        nhl.save()
        
        newTeam.league = nhl
        
        newTeam.save(flush:true)
        
        assertEquals 1, Team.list().size()
    }
    
    void testAddPlayerToTeam() {
        League nhl = TestDataCreator.createNHL()
        Team mnWild = TestDataCreator.createTeamMnWild()
        Player gaborik = TestDataCreator.createMarianGaborik()
        
        nhl.addToTeams(mnWild)
        nhl.save()
        
        // Add to players
        mnWild.addToPlayers(gaborik)
        mnWild.save(flush:true)
        
        assertEquals 1, Team.get(mnWild.id).players.size()
    }
}
