import java.util.GregorianCalendar
/*
 * Copyright (c) Torey Lomenda.  All Rights Reserved.
 */



/**
 * @author tlomenda
 * @author $Author: opi-amiller $
 * @version $Revision: 10150 $
 */
public final class TestDataCreator {

    static League createNHL() {
        Date since = new GregorianCalendar(1917, Calendar.SEPTEMBER, 01).time
        return new League(name: "NHL", description: "National Hockey League", sinceDate: since)
    }
    
    static Team createTeamMnWild() {
        return new Team(name: 'Minnesota Wild', playsIn: 'Saint Paul, MN', playsInArena: "Excel Center")
    }
    
    static Team createTeamNJDevils() {
        return new Team(name: 'New Jersey Devils', playsIn: 'Newark, NJ', playsInArena: "Prudential Center")
    }
    
    static Player createMarianGaborik() {
        return new Player(number: 10, firstName: 'Marian', lastName: 'Gaborik')
    }
    
    static Player createPatrikElias() {
        return new Player(number: 26, firstName: 'Patrik', lastName: 'Elias')
    }
    
    static Player createSidneyCrosby() {
        return new Player(number: 87, firstName: 'Sidney', lastName: 'Crosby')
    }
    
    static Player createMartinBrodeur() {
        return new Player(number: 30, firstName: 'Martin', lastName: 'Brodeur')
    }
    
    static Game createGame() {
        Date gameTime = new GregorianCalendar(2009, Calendar.FEBRUARY, 19, 0, 0).time;
        return new Game(gameTime: gameTime, location: 'Excel Center')
    }
    
    static Season createSeason(int startYear, int endYear) {
        Date seasonStart = new GregorianCalendar(startYear, Calendar.SEPTEMBER, 01).time
        Date seasonEnd = new GregorianCalendar(endYear, Calendar.JUNE, 30).time
        Season season = new Season(fromDate:seasonStart, toDate:seasonEnd)
        return season
    }
    
    static ScoutingReport createScoutingReport(User user, Player player) {
        ScoutingReport report = new ScoutingReport(generalNotes: 'These are the general notes for this report.')
        
        report.addToScoutingNotes(new ScoutingNotes(note: 'Sample note.'))
        report.player = player
        report.scout = user
        
        return report
    }
}
