class UserTests extends GroovyTestCase {

    void testAddingTeamsToAdminister() {

    }
    
    void testAddingScoutingReports() {
        User user = new User(username: 'tlomenda', password: 'password', email:'xx@xx.com', passwd: 'password', userRealName: 'El Chapo')
        ScoutingReport scoutingReport = createNewScoutingReport()
        
        user.addToScoutingReports(scoutingReport)
        
        user.save(flush:true)
        
        assertEquals 1, ScoutingReport.list().size()
        
    }
    
    private ScoutingReport createNewScoutingReport() {
        def nhl = TestDataCreator.createNHL();
        def mnWild = TestDataCreator.createTeamMnWild()
        def gaborik = TestDataCreator.createMarianGaborik()
        
        def scoutingReport = new ScoutingReport()
        
        // Alright build all the pieces
        nhl.addToTeams(mnWild)
        mnWild.addToPlayers(gaborik)
        
        nhl.save(flush:true)
        
        assertEquals 1, Player.list().size()
        
        scoutingReport.player = gaborik
        
        return scoutingReport
    }  
}
