<html>
	<head>
		<meta name="layout" content="main-extjs" />
		<title>Hockey Stats Manager - Scouting Reports</title>
		
		<ext:javascript dir="../../hockeystats" file="DomUtil.js" />
		<ext:javascript dir="../../hockeystats" file="PlayerWatchListPanel.js" />
		<ext:javascript dir="../../hockeystats" file="ScoutingReportInfoPanel.js" />
		
		<ext:javascript dir="../../hockeystats" file="ScoutingReportAdapter.js" />
		
		<ext:javascript dir="../../hockeystats" file="PlayerSearchPanel.js" />
		
		<script type="text/javascript" charset="utf-8">
			if (Ext.type(contentPanelConfig)) {
				Ext.apply(contentPanelConfig, {
					layout: 'border',
					items: [
						{
							region: 'west',
							xtype: 'panel',
							contentEl: 'playerWatchListLayoutPanel',
							title: 'Player Watch List',
							split: true,
							collapsible: true,
							collapseMode: 'mini',
							width: 250,
							maxSize: 300,
							minSize: 100,
							items: [
								{xtype: 'hockeystats.panel.PlayerWatchListPanel', renderTo: 'playerWatchListTreePanel'}
							]
					    },
					    {
						    region: 'center',
						    xtype: 'panel',
						    autoScroll: true,
						    contentEl: 'scoutingReportsLayoutPanel',
						    items: [
						            {xtype: 'hockeystats.panel.ScoutingReportInfoPanel', renderTo: 'scoutingReportInfoPanel'}
							]
					    },
					    {
						    region: 'east',
						    xtype: 'panel', 
						    width: 300,
						    contentEl: 'playerSearchLayoutPanel',
						    items: [
						            {xtype: 'hockeystats.panel.PlayerSearchPanel', renderTo: 'playerSearchPanel'}
							]
					    }
					],

					// Register listeners once this component is rendered
					listeners: {
						render:	{
							fn: function(contentPanel) {
								// The reporting info panel needs to listen to the Tree panel selection to update its state.
								// Do this through an adapter.
								hockeystats.events.ScoutingReportAdapter.registerLoadReportListener(contentPanel);
							},
							single: true
						}
					},

					// Let us add some custom functions as convenient item accessors (used to register listeners after the component is rendered)
					getPlayerWatchListPanel: function() {
						// Get the tree panel from the content panel.
						var westPanel = this.items.get(0);					
						return westPanel.items.get(0); // Based on the layout, this is the panel we want
					},

					getScoutingReportInfoPanel: function() {
						// Get the tree panel from the content panel.
						var centerPanel = this.items.get(1);					
						return centerPanel.items.get(0); // Based on the layout, this is the panel we want
					}
				});
			}
		</script>
	</head>
	
	<!-- This will be all Ext JS baby -->
	<body>
		<noscript>
			<a href="${createLink(controller: 'scoutingReport', action:'list')}">Alternative site for Scouting Reports</a>
		</noscript>
		<div id="playerWatchListLayoutPanel">	
			<div id="playerWatchListTreePanel"><noscript>Player Watch List</noscript></div>
		</div>
		<div id="scoutingReportsLayoutPanel">
			<div id="scoutingReportInfoPanel"><noscript>Scouting Report</noscript></div>
		</div>
		<div id="playerSearchLayoutPanel">
			<div id="playerSearchPanel"><noscript>Player Search</noscript></div>
		</div>
	</body>
</html>