/**
 * This Event Adapter is used to change the state of the ScoutingReportInfoPanel when a player is selected from the PlayerWatchListPanel
 * @author tlomenda
 */

Ext.namespace('hockeystats.events')

hockeystats.events.PlayerInfoAdapter = function() {
	
	return {
		/**
		 * This is used to register a listener when a node is clicked on the player watch list to load the scouting report into the UI.
		 */
		registerLoadPlayerListener: function(contentPanel) {
			var teamListPanel = contentPanel.getTeamListPanel();
			var playerInfoPanel = contentPanel.getPlayerInfoPanel();
			
			// Register the listener
			teamListPanel.on('click', function(node, event) {
				this.updateInfo(node.id);
			}, playerInfoPanel);
			
		}
	}
}();
