<html>
	<head>
		<meta name="layout" content="main-yui" />
		<title>Hockey Stats Manager - Scouting Reports</title>
		
		<!-- Load he GrailsUI Resources -->
		<gui:resources components="['accordion', 'dialog', 'richEditor', 'dataTable', 'autoComplete']"/>
		
		<!-- Load YUI Libraries, CSS or GrailsUI components needed -->
		<yui:stylesheet dir="assets/skins/sam" file="treeview.css" />
		<yui:stylesheet dir="assets/skins/sam" file="treecontrol.css" />
		
		<yui:javascript dir="treeview" file="treeview-min.js" />
		
		<!-- Custom Javascript -->
		<yui:javascript dir="../../hockeystats" file="PlayerWatchListPanel.js" />
		
		<%-- Configure the nested layout for the content layout --%>
		<script type="text/javascript">
			var contentUnits = [ 
	            { position: 'left', body: 'playerWatchListLayoutPanel', header: 'Player Watch List', resize: true, collapse: true, width: 250}, 
	            { position: 'center', body: 'scoutingReportsLayoutPanel'},
	            { position: 'right', body: 'playerSearchLayoutPanel', width:300}  
	        ];
		</script>

	</head>
	
	<!-- This is where the GrailsUI magic will happen -->
	<body>
		<noscript>
			<a href="${createLink(controller: 'scoutingReport', action:'list')}">Alternative site for Scouting Reports</a>
		</noscript>
		<div id="playerWatchListLayoutPanel">	
			<div id="playerWatchListTreePanel"><noscript>Player Watch List</noscript></div>
		</div>
		<div id="scoutingReportsLayoutPanel">
			<!-- Build the accordions with GrailsUI -->
			<div id="scoutingReportInfoPanel">
				<noscript>Scouting Report</noscript>
				<gui:accordion id="scoutingReportAccordion">
					<gui:accordionElement id="playerScoutingReportPanel" title="Scouting Report">
						<!-- See the CSS to see how this is styled -->
						<form id="scoutingReport-form" method="post" action="#">
							<fieldset>
								<legend>Player Ratings (1-10)</legend>
								<table>
									<tbody>
										<tr>
											<td>Skating:</td>
											<td><input id="report-ratingSkating" type="text" name="ratingSkating" value="" size="20"/></td>
											<td>Puck Control:</td>
											<td><input id="report-ratingPuckControl" type="text" name="ratingPuckControl" value="" size="20"/></td>
										</tr>
										<tr>
											<td>Physical Play:</td>
											<td><input id="report-ratingPhysicalPlay" type="text" name="ratingPhysicalPlay" value="" size="20"/></td>
											<td>Size:</td>
											<td><input id="report-ratingSize" type="text" name="ratingSize" value="" size="20"/></td>
										</tr>
										<tr>
											<td>Intensity:</td>
											<td><input id="report-ratingIntensity" type="text" name="ratingIntensity" value="" size="20"/></td>
											<td>Hockey Sense:</td>
											<td><input id="report-ratingHockeySense" type="text" name="ratingHockeySense" value="" size="20"/></td>
										</tr>
										<tr>
											<td>Offensive Play:</td>
											<td><input id="report-ratingOffensivePlay" type="text" name="ratingOffensivePlay" value="" size="20"/></td>
											<td>Defensive Play:</td>
											<td><input id="report-ratingDefensivePlay" type="text" name="ratingDefensivePlay" value="" size="20"/></td>
										</tr>
									</tbody>
								</table>
							</fieldset>
							<fieldset>
								<legend>Player Notes</legend>
								<table>
									<tbody>
										<tr>
											<td>Strengths:</td>
											<td><textarea id="report-strengths" width="500" height="40" name="stengths"></textarea></td>
										</tr>
										<tr>
											<td>Weaknesses:</td>
											<td><textarea id="report-weaknesses" width="500" height="40" name="weaknesss"></textarea></td>
										</tr>
										<tr>
											<td>Tendencies:</td>
											<td><textarea id="report-tendencies" width="500" height="40" name="tendencies"></textarea></td>
										</tr>
										<tr>
											<td>General:</td>
											<td><textarea id="report-general" width="500" height="40" name="general"></textarea></td>
										</tr>
									</tbody>
								</table>
							</fieldset>
							
							<div id="buttons">
								<button type="submit" id="scoutingReport-submit">Update</button>
							</div>
							<script type="text/javascript">
							 	var submitButton = new YAHOO.widget.Button("scoutingReport-submit", {
					                disabled: false
					            });
							</script>
						</form>
					</gui:accordionElement> 
					
					<gui:accordionElement id="playerScoutingNotesPanel" title="Player Scouting Notes">
						<div id="playerScoutingNotesDataTable">
							<!-- No Paginator right now for the demo -->
							<gui:dataTable
							    id="scoutingNotesDataTable"
							    draggableColumns="true"
							    columnDefs="[
							        [key:'id', sortable:true, resizeable: true, label:'ID'],
							        [key:'note', sortable:true, resizeable: true, label:'Note'],
							        [key:'dateLogged', type:'date', sortable:true, resizeable: true, label: 'Date Logged']
							    ]"
							    paginatorConfig="[template: '']" 
							    controller="scoutingReport" action="showREST"
							    params="[id:0]"
							    resultsList="scoutingNotes"
							    rowExpansion="false"
							    rowsPerPage="10"
							/>
						</div>
						<div>
							<br />
							<button type="button" id="playerNotesEditorButton"></button>
							
							<script type="text/javascript">
								var oButton = new YAHOO.widget.Button('playerNotesEditorButton', { label: "Edit Note" }); 
							</script>
						</div>
					</gui:accordionElement> 
				</gui:accordion>
			</div>
		</div>
		<div id="playerSearchLayoutPanel">
			<div id="playerSearchPanel">
				<noscript>Player Search</noscript>
			
				<p style="margin-top: 5px; margin-bottom: 2px;"><b>Player Search</b>
				<gui:autoComplete
				        id="playerSearch-autoComplete"
				        resultName="players"
				        labelField="resultLabel"
				        idField="id"
				        controller="player"
				        action="showByNameREST"
				        minQueryLength="1"
				        typeAhead="false"
				        allowBrowserAutocomplete="false"
				        resultTypeList="false"/>
			</div>
		</div>
		
		<!--  A dialog with a rich editor -->
		<gui:dialog
		    title="Edit Player Scouting Notes"
		    draggable="false"
		    modal="true"
		    buttons="[
		        [text:'Ok', handler: 'function() {this.cancel()}', isDefault: true]
		    ]"
		    triggers="[
   				show:[id:'playerNotesEditorButton', on:'click']
   			]"> 			
   				<gui:richEditor id='myPlayerNotesEditor' value='Dynamically change the content based on the selected note.'/>
   		</gui:dialog>	
		
		<!-- Perform the YUI goodness -->
		<script type="text/javascript">
		// This does not work.  Remember event-driven app.  This will be executed before the data table is created!!
		// GRAILSUI.scoutingNotesDataTable.handleDataReturnPayload = function() {};
		
			YAHOO.util.Event.onAvailable('playerWatchListTreePanel', YAHOO.hockeystats.panel.PlayerWatchListPanel.initTree);
			YAHOO.util.Event.onAvailable('playerSearch-autoComplete', function() {
				var attachCustomGrailsUIBehaviour = function() {
					if (!!GRAILSUI.playerSearch_autoComplete && !!GRAILSUI.scoutingNotesDataTable) {
						clearInterval(intervalId);

						// Attach behaviour to the data table
						// I am not interested in returning "totalRecords" in the REST response.
		                // This function gets generated by GRAILS UI, so I am providing an empty function for now
		                GRAILSUI.scoutingNotesDataTable.handleDataReturnPayload = function() {
			                // Do nothing
		                };

						// Attach behaviour to the autoComplete Control
						GRAILSUI.playerSearch_autoComplete.dataSource.doBeforeParseData = function(request, response, callback) {
							if (!!response && !!response.players) {
	
								// attach a special label so I can format the result
								if (!!response.players) {
									for (var i=0; i < response.players.length; i++) {
										var player = response.players[i];
										response.players[i].resultLabel = player.id + "," + player.teamName + "," + player.number + "," + player.firstName + "," + player.lastName; 
									}
								}
							}
							return response;
						};
					}

					GRAILSUI.playerSearch_autoComplete.formatResult = function(oResultData, sQuery, sResultMatch) { 
						if (!!oResultData.resultLabel) {
							var data = oResultData.resultLabel.split(",");
							var resultId = 'player-search-item-' + data[0];
							var aMarkup = ['<div class="player-search-item" id="', resultId, '">',
		               	      '<span style="font-weight:bold">', data[2], ' ', data[3], ' ', data[4], '</span>',
		               	      '<br />',
		               	      '<span>(', data[1], ')</span>', 
		               	      '</div>']; 

							// Create a dragabble object
							var dd = new YAHOO.util.DDProxy(resultId);
							dd.isTarget = false;

							dd.startDrag = function() {
								dd.setDelta(0,0);
							};
							
							dd.onDragDrop = function(event, id) {
								if (id === 'playerWatchListTreePanel') {
									// Add the new report
									var playerId = data[0];

									var callback = {
										success: function(o) { YAHOO.hockeystats.panel.PlayerWatchListPanel.refreshTree() },
										failure: function(o) { alert("Failed.  That sucks!!"); }
										
									};
									var transaction = YAHOO.util.Connect.asyncRequest("POST", HockeyStats.SCOUT_REPORT_REST_URL, callback, "playerId=" + playerId);
								}
							};
							
							return (aMarkup.join(""));
						}						
					}
				}

				var intervalId = setInterval(attachCustomGrailsUIBehaviour, 50);

				// Set the dd target
				var dropTarget = new YAHOO.util.DDTarget('playerWatchListTreePanel');
				
			});
		</script>
	</body>
</html>