YAHOO.namespace("hockeystats.panel");

YAHOO.hockeystats.panel.PlayerWatchListPanel = function() {

    var scoutingReportUrl = HockeyStats.SCOUT_REPORT_REST_URL;
	
	var tree = undefined;
    
    function _createScoutingReportNodes(jsonText, node) {
        var jsonObj = YAHOO.lang.JSON.parse(jsonText);
        
        // New array for our team nodes
        playerWatchNodes = [];
        
        if (!!jsonObj.scoutingReports) {
            var scoutingReports = jsonObj.scoutingReports;
            
            for (var i = 0; i < scoutingReports.length; i++) {
                var report = scoutingReports[i];
                
                // Add the node
                var reportNode = new YAHOO.widget.TextNode({
                    label: '<img src="../images/hockeystats/player.gif" height="18" width="18" />' + report.number + ' - ' + report.firstName + ' ' + report.lastName,
                    id: report.id + '-' + report.playerId
                }, node);
                
                reportNode.id = report.id;
                reportNode.labelElId = 'reportNode-' + report.id + '-' + report.playerId;
                reportNode.labelStyle = 'icon-player';
                playerWatchNodes.push(reportNode);
            }
        }
    }
    
    function _loadData(node, onCompleteCallback) {
    
        // Closure around the node
        var parentNode = node;
        var parentNodeId = node.id;
        
        var handleSuccess = function(response) {
            // Create player nodes for the Team
            _createScoutingReportNodes(response.responseText, parentNode);
            
            // Need to notify the tree that the loadData is complete
            onCompleteCallback();
        }
        
        
        var callback = {
            success: handleSuccess,
            failure: function(o) {
                alert("There was a problem creating Team List Nodes!!");
            }
        }
        
        var transaction = YAHOO.util.Connect.asyncRequest("GET", scoutingReportUrl, callback);
    }
    
    function _initializeClickEventToRefreshScoutingReportData(tree) {
        // Register events when a node is clicked and it has a scouting report id
        tree.subscribe("clickEvent", function(event) {
        
            // Fetch the scouting report information
            var callback = {
                success: GRAILSUI.scoutingNotesDataTable.onDataReturnInitializeTable,
                failure: function(o) {
                    alert("There was a problem refreshing the data!!");
                },
                scope: GRAILSUI.scoutingNotesDataTable
            };
            
            if (event.node.id !== 'playerWatchListParentNode') {
				
				// I can override this to set the player profile info from the response returned by sending a request on this data source
				GRAILSUI.scoutingNotesDataTable.getDataSource().doBeforeParseData = function(request, fullResponse, callback) {
					YAHOO.util.Dom.get('report-ratingSkating').value = fullResponse.scoutingReport.ratingSkating;
                    YAHOO.util.Dom.get('report-ratingPuckControl').value = fullResponse.scoutingReport.ratingPuckControl;
                    YAHOO.util.Dom.get('report-ratingPhysicalPlay').value = fullResponse.scoutingReport.ratingPhysicalPlay;
					YAHOO.util.Dom.get('report-ratingSize').value = fullResponse.scoutingReport.ratingSize;
					YAHOO.util.Dom.get('report-ratingIntensity').value = fullResponse.scoutingReport.ratingIntensity;
					YAHOO.util.Dom.get('report-ratingHockeySense').value = fullResponse.scoutingReport.ratingHockeySense;
					YAHOO.util.Dom.get('report-ratingOffensivePlay').value = fullResponse.scoutingReport.ratingOffensivePlay;
					YAHOO.util.Dom.get('report-ratingDefensivePlay').value = fullResponse.scoutingReport.ratingDefensivePlay;
					YAHOO.util.Dom.get('report-strengths').value = fullResponse.scoutingReport.strengths ? fullResponse.scoutingReport.strengths : '';
					YAHOO.util.Dom.get('report-weaknesses').value = fullResponse.scoutingReport.weaknesses ? fullResponse.scoutingReport.weaknesses : '';
					YAHOO.util.Dom.get('report-tendencies').value = fullResponse.scoutingReport.tendencies ? fullResponse.scoutingReport.tendencies : '';
					YAHOO.util.Dom.get('report-general').value = fullResponse.scoutingReport.generalNotes ? fullResponse.scoutingReport.generalNotes : '';
					
					return fullResponse;
				};
                GRAILSUI.scoutingNotesDataTable.getDataSource().sendRequest("id=" + event.node.id, callback);
            }
        });
    }
    
    return {
        initTree: function() {
        
            // Create the tree view object
            tree = new YAHOO.widget.TreeView('playerWatchListTreePanel');
            
            // Define the root node
            var root = tree.getRoot();
            var teamListNode = new YAHOO.widget.TextNode({
                label: 'My Player Watch List',
                labelElId: 'playerWatchListParentNode'
            }, root, false); // note expanded 
            // Add the nodes (dynamically).  NOTE:  Have to attach other proerpties it to the node explicitly.  Even labelElId which is said to be supported!! :-(
            teamListNode.id = 'playerWatchListParentNode';
            teamListNode.labelElId = 'playerWatchListParentNode';
            teamListNode.setDynamicLoad(_loadData);
            
            // Draw the tree
            tree.draw();
            
            _initializeClickEventToRefreshScoutingReportData(tree);
        },
		
		refreshTree: function() {
			var mainNode = tree.getRoot().children[0];
			
			tree.removeChildren(mainNode);
		}
    }
}();
