<html>
    <head>
    	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
        <title>
        	<g:layoutTitle default="Hockey Stats Manager" />
        </title>
        
        <yui:stylesheet dir="reset-fonts-grids" file="reset-fonts-grids.css" />
         <yui:stylesheet dir="base" file="base.css" />
        <yui:stylesheet dir="assets/skins/sam" file="resize.css" />
        <yui:stylesheet dir="assets/skins/sam" file="layout.css" />
        
        <yui:stylesheet dir="assets/skins/sam" file="menu.css" />
        
        <!--  Custom CSS -->
        <yui:stylesheet dir="../../../css" file="hockeystats.css" />
        
        
        
        <!-- Load the YUI Libraries -->
        <g:javascript library="yui" />
        
        <yui:javascript dir="yahoo-dom-event" file="yahoo-dom-event.js" />
        <yui:javascript dir="element" file="element-beta-min.js" />
        <yui:javascript dir="dragdrop" file="dragdrop-min.js" />
        <yui:javascript dir="resize" file="resize-min.js" />
        <yui:javascript dir="animation" file="animation-min.js" />
        <yui:javascript dir="layout" file="layout-min.js" />
        <yui:javascript dir="json" file="json-min.js" />
        <yui:javascript dir="connection" file="connection-min.js" />
        
        <!-- GrailsUI Resources -->
        <gui:resources components="dialog"/>
        
        <script type="text/javascript" charset="utf-8">
        var HockeyStats = {
        		BASE_URL: '<g:createLinkTo dir="" file="" />',
        		LEAGUE_REST_URL: '<g:createLinkTo dir="rest/league" file=""/>',
        		TEAM_REST_URL: '<g:createLinkTo dir="rest/team" file=""/>',
        		PLAYER_REST_URL: '<g:createLinkTo dir="rest/player" file=""/>',
        		SCOUT_REPORT_REST_URL: '<g:createLinkTo dir="rest/scoutingReport" file=""/>',
        		LEAGUE_ADMIN_URL: '<g:createLink controller="leagueAdmin" />',
        		PLAYER_MGMT_URL: '<g:createLink controller="playerMgmt" />',
        		SCOUTING_URL: '<g:createLink controller="scouting" />',
        		SCOUTING_NOTES_URL: '<g:createLink controller="scouting" action="scoutingNotes"/>',
        		Roles: {
            		leagueAdmin: false,
            		playerAdmin: false,
            		playerScout: false
            		
        		}
        	};
		</script>
		
		<%-- Initialize the Security Roles Config (Acegi plugin Taglib) --%>
        <g:ifAllGranted role="ROLE_LEAGUE_ADMIN">
        	<script type="text/javascript" charset="utf-8">
	        	HockeyStats.Roles.leagueAdmin = true;
			</script>
        </g:ifAllGranted>
        <g:ifAllGranted role="ROLE_PLAYER_ADMIN">
        	<script type="text/javascript" charset="utf-8">
        		HockeyStats.Roles.playerAdmin = true;
			</script>
        </g:ifAllGranted>
        <g:ifAllGranted role="ROLE_PLAYER_SCOUT">
        	<script type="text/javascript" charset="utf-8">
        		HockeyStats.Roles.playerScout = true;
			</script>
        </g:ifAllGranted>
        
        <g:layoutHead />
        
        <!--  Custom Javascript.  For whatever reason, loading a GrailsUI dataTable component after our menubar messes our menubar up.  Datatable uses the menuing as well.  -->
        <%-- Adding in Menu support for YUI --%>
        <yui:javascript dir="container" file="container_core-min.js" />
        <yui:javascript dir="menu" file="menu-min.js" />
        
        <yui:javascript dir="../../hockeystats" file="Menubar.js" />
    </head>
    
    <body class="yui-skin-sam">
    	<NOSCRIPT>JavaScript not supported.  Provide a link to an alternative accessible site.</NOSCRIPT> 

    	<%-- Continue with laying out the body for the page --%>
    	<div id="header">
    		<div id="header-logo">
				<table>
					<tbody>
						<tr>
							<td><img src="${createLinkTo(dir:'images/hockeystats',file:'logo.jpg')}"></img></td>
							<td>Hockey Statistics Manager</td>
						</tr>
					</tbody>
				</table>
			</div>
			<div id="header-menu">
				<noscript>
					<a href="${createLink(controller:'leagueAdmin')}">League Administration</a>|
					<a href="${createLink(controller:'playerMgmt')}">Player Administration</a>|
					<a href="${createLink(controller:'scouting')}">Scouting Reports</a>
				</noscript>
			</div>
    	</div>
    	<div id="content">
    		<g:layoutBody />
    		
    		<gui:dialog
			    title="About Hockey Stats"
			    draggable="false"
			    modal="true"
			    buttons="[
			        [text:'Ok', handler: 'function() {this.cancel()}', isDefault: true]
			    ]"
			    triggers="[
    				show:[id:'help-about', on:'click']
    			]">Hockey Stats 0.1.  This is a Demo for Javascript on Grails!!</gui:dialog>	
    	</div>
    	<div id="footer">
    		Copyright 2009 - Torey Lomenda
    	</div>
    </body>
    
    <%-- Initialize the layout for the page.  Notice it is the last part of the page. --%>
    <script type="text/javascript">   
		YAHOO.util.Event.onDOMReady(function() {
			var layout = new YAHOO.widget.Layout({
				units: [
				    {
					    position: 'top',
					    height: 122,
					    body: 'header'
				    },
				    {
					    position: 'center',
					    body: 'content'
				    },
				    {
					    position: 'bottom',
					    height: 30,
					    body: 'footer'
				    }       
				]
		    });

		    layout.on('render', function() {
				var el = layout.getUnitByPosition('center').get('wrap'); 

				var layout2 = new YAHOO.widget.Layout(el, { 
			        parent: layout, 
			        units: contentUnits
			    }); 
			    
			    layout2.render(); 
			});

		 	// Initialize the menubar
			var menubar = new YAHOO.hockeystats.menu.Menubar();

			// Render the layout
			layout.render();
			menubar.render("layout-doc");
    	});
	</script>	
</html>