<html>
	<head>
		<meta name="layout" content="main-yui" />
		<title>Hockey Stats Manager - Player Management</title>
		
		<!-- Load he GrailsUI Resources -->
		<gui:resources components="['accordion', 'tabView', 'dialog', 'richEditor', 'dataTable']"/>
		
		<!-- Load YUI Libraries, CSS or GrailsUI components needed -->
		<yui:stylesheet dir="assets/skins/sam" file="treeview.css" />
		<yui:stylesheet dir="assets/skins/sam" file="treecontrol.css" />
		
		<yui:javascript dir="treeview" file="treeview-min.js" />
		
		<yui:javascript dir="../../hockeystats" file="TeamListPanel.js" />
		
		<%-- Configure the nested layout for the content layout --%>
		<script type="text/javascript">
			var contentUnits = [ 
	            { position: 'left', body: 'teamListPanel', header: 'Team List', resize: true, collapse: true, width: 250}, 
	            { position: 'center', body: 'playerMgmtPanel'}
	        ];
		</script>

	</head>
	
	<!-- This is where the GrailsUI magic will happen -->
	<body>
		<noscript>
			<a href="${createLink(controller: 'player', action:'list')}">Alternative site for Player Management</a>
		</noscript>
		<div id="teamListPanel">
			<!--  Team List -->
			<div id="teamListTree"><noscript>Team List</noscript></div>
		</div>
		
		<div id="playerMgmtPanel">
			<!--  Player Profile, Stats & News -->
			<div id="playerInfoPanel">
				<noscript>Player Profile, Stats & News</noscript>
				
				<!-- User Grails UI to create accordion panels and tab panels -->
				<gui:accordion id="playerProfileInfoAccordion" class="myAccordion">
					<gui:accordionElement id="playerProfilePanel" title="Player Profile">
						<!-- See the CSS to see how this is styled -->
						<form id="player-form" method="post" action="#">
							<fieldset>
								<legend>Profile</legend>
								<table>
									<tbody>
										<tr>
											<td>Number:</td>
											<td><input id="player-number" type="text" name="number" value="" size="100"/></td>
										</tr>
										<tr>
											<td>First Name:</td>
											<td><input id="player-firstName" type="text" name="firstName" value="" size="300"/></td>
										</tr>
										<tr>
											<td>Last Name:</td>
											<td><input id="player-lastName" type="text" name="lastName" value="" size="300"/></td>
										</tr>
										<tr>
											<td>Height (Feet):</td>
											<td><input id="player-heightFeet" type="text" name="heightFeet" value="" size="100"/></td>
										</tr>
										<tr>
											<td>Height (Inches):</td>
											<td><input id="player-heightInches" type="text" name="heightInches" value="" size="100"/></td>
										</tr>
										<tr>
											<td>Weight (lbs):</td>
											<td><input id="player-weightInPounds" type="text" name="weightInPounds" value="" size="100"/></td>
										</tr>
									</tbody>
								</table>
							</fieldset>
							
							<div id="buttons">
								<button type="submit" id="player-submit">Update</button>
							</div>
							<script type="text/javascript">
							 	var submitButton = new YAHOO.widget.Button("player-submit", {
					                disabled: false
					            });
							</script>
						</form>
					</gui:accordionElement> 
					
					<gui:accordionElement id="playerStatsAndNewsPanel" title="Player Stats & News">
						<gui:tabView>
						    <gui:tab id="playerStatsPanel" label="Stats" active="true">
						        <div id="playerStatsDataTable">
									<!-- No Paginator right now for the demo -->
									<gui:dataTable
									    id="playerStatsDataTable"
									    draggableColumns="true"
									    columnDefs="[
									        [key:'goals', sortable:true, resizeable: true, label:'Goals'],
									        [key:'assists', sortable:true, resizeable: true, label:'Assists'],
									        [key:'plusMinus', sortable:true, resizeable: true, label: 'Plus/Minus'],
									        [key:'hits', type:'date', resizeable: true, label: 'Hits'],
									        [key:'takeAways', sortable:true, resizeable: true, label: 'Take Aways'],
									        [key:'scoringChances', sortable:true, resizeable: true, label: 'Scoring Chances'],
									        [key:'playResultedInGoalFor', sortable:true, resizeable: true, label: 'Play-Goal For'],
									        [key:'pims', resizeable: true, label: 'PIMs'],
									        [key:'giveAways', sortable:true, resizeable: true, label: 'Give Aways'],
									        [key:'playResultedInGoalAgainst', sortable:true, resizeable: true, label: 'Play-Goal Against']
									    ]"
									    sortedBy="goals"
									    paginatorConfig="[template: '']" 
									    controller="player" action="showWithPlayerStatsREST"
									    params="[id:0]"
									    resultsList="playerStats"
									    rowExpansion="false"
									    rowsPerPage="10"
									/>
								</div>
								<div>
									<br />
									<button type="button" id="playerStatsButton"></button>
									
									<script type="text/javascript">
										var oButton = new YAHOO.widget.Button('playerStatsButton', { label: "Edit Stats" }); 
									</script>
								</div>
						    </gui:tab>
						    <gui:tab id="playerNewsPanel" label="News">
						        <div id="playerNewsDataTable">
									<!-- No Paginator right now for the demo -->
									<gui:dataTable
									    id="playerNewsDataTable"
									    draggableColumns="true"
									    columnDefs="[
									        [key:'newsDate', type:'date', sortable:true, resizeable: true, label: 'Date'],
									        [key:'news', sortable:true, resizeable: true, label:'News Item']
									        
									    ]"
									    sortedBy="newsDate"
									    paginatorConfig="[template: '']" 
									    controller="player" action="showWithPlayerNewsREST"
									    resultsList="playerNews"
									    params="[id:0]"
									    rowExpansion="false"
									    rowsPerPage="10"
									/>
									
									<div>
										<br />
										<button type="button" id="playerNewsEditorButton"></button>
										
										<script type="text/javascript">
											var oButton = new YAHOO.widget.Button('playerNewsEditorButton', { label: "Edit News" }); 
										</script>
									</div>
								</div>
						    </gui:tab>
						</gui:tabView>
					</gui:accordionElement> 
				</gui:accordion>
			</div>
		</div>
		
		<!--  A dialog with a rich editor -->
		<gui:dialog
		    title="Edit Player News"
		    draggable="false"
		    modal="true"
		    buttons="[
		        [text:'Ok', handler: 'function() {this.cancel()}', isDefault: true]
		    ]"
		    triggers="[
   				show:[id:'playerNewsEditorButton', on:'click']
   			]"> 			
   				<gui:richEditor id='myPlayerNewsEditor' value='Dynamically change the content based on the selected news item.'/>
   		</gui:dialog>	
		
		<!-- Perform the YUI goodness -->
		<script type="text/javascript">
			YAHOO.util.Event.onAvailable('teamListTree', YAHOO.hockeystats.panel.TeamListPanel.initTree);

			YAHOO.util.Event.onAvailable('playerStatsDataTable', function() {
				var attachCustomGrailsUIBehaviour = function() {
					if (!!GRAILSUI.playerStatsDataTable) {
						clearInterval(intervalId);
						
						// I am not interested in returning "totalRecords" in the REST response.
			            // This function gets generated by GRAILS UI, so I am providing an empty function for now
			            GRAILSUI.playerStatsDataTable.handleDataReturnPayload = function() {
			            };
					}
				};

				var intervalId = setInterval(attachCustomGrailsUIBehaviour, 50);
			});

			YAHOO.util.Event.onAvailable('playerNewsDataTable', function() {
				var attachCustomGrailsUIBehaviour = function() {
					if (!!GRAILSUI.playerNewsDataTable) {
						clearInterval(intervalId);
						
						// I am not interested in returning "totalRecords" in the REST response.
			            // This function gets generated by GRAILS UI, so I am providing an empty function for now
						GRAILSUI.playerNewsDataTable.handleDataReturnPayload = function() {
			            };
					}
				};

				var intervalId = setInterval(attachCustomGrailsUIBehaviour, 50);
			});
		</script>
	</body>
</html>