import java.util.GregorianCalendar
import grails.util.GrailsUtil
class BootStrap {

     def init = { servletContext ->
     
         switch (GrailsUtil.environment) {
             case "development" : 
                 loadForDev()
             default: break
         }
         
         // Look at overriding the javascript libraries that get loaded (in prod probably have compressed versions
         // JavascriptTagLib.LIBRARY_MAPPINGS.ext += ["ext/2.0.2/build/widgets/MessageBox-min", ..]
     }
     
     def destroy = {
     }
     
     private void loadForDev() {
         // Users (5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8 = password)
         User playerAdmin1 = new User(username:'playeradmin1', passwd: '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', userRealName: 'Joe Playeradmin1', email:'test@test.com', enabled: true)
         User playerAdmin2 = new User(username:'playeradmin2', passwd: '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', userRealName: 'Joe Playeradmin2', email:'test@test.com', enabled: true)
         User scout1 = new User(username:'scout1', passwd: '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', userRealName: 'Joe Scout2', email:'test@test.com', enabled: true)
         User scout2 =new User(username:'scout2', passwd: '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', userRealName: 'Joe Scout2', email:'test@test.com', enabled: true)
         User leagueAdmin = new User(username:'leagueadmin', passwd: '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', userRealName: 'Joe Leagueadmin', email:'test@test.com', enabled: true)
         User superUser = new User(username:'superuser', passwd: '5baa61e4c9b93f3f0682250b6cf8331b7ee68fd8', userRealName: 'Joe Super', email:'test@test.com', enabled: true)
         
         // Roles
         Role leagueAdminRole = new Role(authority: 'ROLE_LEAGUE_ADMIN', description: 'League Administrator')
         Role playerAdminRole = new Role(authority: 'ROLE_PLAYER_ADMIN', description: 'Player Administrator')
         Role scoutRole = new Role(authority: 'ROLE_PLAYER_SCOUT', description: 'Player Scout')
         
         leagueAdminRole.addToPeople(leagueAdmin)
         leagueAdminRole.addToPeople(superUser)
         playerAdminRole.addToPeople(playerAdmin1)
         playerAdminRole.addToPeople(playerAdmin2)
         playerAdminRole.addToPeople(superUser)
         scoutRole.addToPeople(scout1)
         scoutRole.addToPeople(scout2)
         scoutRole.addToPeople(superUser)
         
         leagueAdminRole.save()
         playerAdminRole.save()
         scoutRole.save()
         
         // Request mapping
         new RequestMapping(url:'/user/**', configAttribute: 'ROLE_LEAGUE_ADMIN').save()
         new RequestMapping(url:'/role/**', configAttribute: 'ROLE_LEAGUE_ADMIN').save()
         new RequestMapping(url:'/requestMapping/**', configAttribute: 'ROLE_LEAGUE_ADMIN').save()
         new RequestMapping(url:'/leagueAdmin/**', configAttribute: 'ROLE_LEAGUE_ADMIN').save()
         new RequestMapping(url:'/league/**', configAttribute: 'ROLE_LEAGUE_ADMIN').save()
         new RequestMapping(url:'/team/**', configAttribute: 'ROLE_LEAGUE_ADMIN').save()
         new RequestMapping(url:'/season/**', configAttribute: 'ROLE_LEAGUE_ADMIN').save()
         new RequestMapping(url:'/game/**', configAttribute: 'ROLE_LEAGUE_ADMIN').save()
         new RequestMapping(url:'/playerMgmt/**', configAttribute: 'ROLE_PLAYER_ADMIN').save()
         new RequestMapping(url:'/player/**', configAttribute: 'ROLE_PLAYER_ADMIN').save()
         new RequestMapping(url:'/scouting/**', configAttribute: 'ROLE_PLAYER_SCOUT').save()
         new RequestMapping(url:'/scoutingReport/**', configAttribute: 'ROLE_PLAYER_SCOUT').save()
         new RequestMapping(url:'/rest/league/**', configAttribute: 'ROLE_LEAGUE_ADMIN').save()
         new RequestMapping(url:'/rest/team/**', configAttribute: 'ROLE_LEAGUE_ADMIN,ROLE_PLAYER_ADMIN').save()
         new RequestMapping(url:'/rest/player/**', configAttribute: 'ROLE_PLAYER_ADMIN').save()
         new RequestMapping(url:'/rest/scoutingReport/**', configAttribute: 'ROLE_PLAYER_SCOUT').save()
         
         
         // Add default Leagues
         League nhlHockey = new League(name:'NHL', description: 'National Hockey League').save()
         
         // Create New Season
         Date fromDate = new GregorianCalendar(2008, GregorianCalendar.SEPTEMBER, 01).time
         Date toDate = new GregorianCalendar(2009, GregorianCalendar.APRIL, 30).time
         
         Season season2008to09 = new Season(fromDate: fromDate, toDate: toDate)
         nhlHockey.addToSeasons(season2008to09)
         
         // Add Teams to the league
         Team wild = new Team(name:'Minnesota Wild', playsIn: 'Saint Paul, MN', playsInArena: 'Excel Center')
         Team devils = new Team(name:'New Jersey Devils', playsIn: 'Newark, NJ', playsInArena: 'Prudential Center')
         Team oilers = new Team(name:'Edmonton Oilers', playsIn: 'Edmonton, AB, Canada', playsInArena: 'Rexall Place')
         Team flames = new Team(name:'Calgary Flames', playsIn: 'Calgary, AB, Canada', playsInArena: 'Pengrowth Saddledome')
         nhlHockey.addToTeams(wild)
         nhlHockey.addToTeams(devils)
         nhlHockey.addToTeams(oilers)
         nhlHockey.addToTeams(flames)
         
         nhlHockey.save(flush:true)
         
         // Games
         Date gameDate1 = new GregorianCalendar(2009, GregorianCalendar.JANUARY, 24).time
         Date gameDate2 = new GregorianCalendar(2009, GregorianCalendar.FEBRUARY, 02).time
         Game game1 = new Game(gameTime: gameDate1, location: 'Excel Center', homeTeam: wild, visitorTeam: flames)
         Game game2 = new Game(gameTime: gameDate1, location: 'Prudential Center', homeTeam: devils, visitorTeam: oilers)
         Game game3 = new Game(gameTime: gameDate2, location: 'Rexall Place', homeTeam: oilers, visitorTeam: wild)
         Game game4 = new Game(gameTime: gameDate2, location: 'Pengrowth Saddledome', homeTeam: flames, visitorTeam: devils)
         
         season2008to09.addToGames(game1)
         season2008to09.addToGames(game2)
         season2008to09.addToGames(game3)
         season2008to09.addToGames(game4)
         season2008to09.save(flush:true)
         
         // Players 
         Player koivu = new Player(firstName: 'Mikko', lastName: 'Koivu', number: 9, heightFeet: 6, heightInches: 1, weightInPounds: 190)
         Player burns = new Player(firstName: 'Brent', lastName: 'Burns', number: 8, heightFeet: 6, heightInches: 1, weightInPounds: 195)
         Player rolston = new Player(firstName: 'Brian', lastName: 'Rolston', number: 12, heightFeet: 5, heightInches: 11, weightInPounds: 185)
         Player elias = new Player(firstName: 'Patrik', lastName: 'Elias', number: 26, heightFeet: 6, heightInches: 0, weightInPounds: 185)
         Player hemsky = new Player(firstName: 'Ales', lastName: 'Hemsky', number: 83, heightFeet: 6, heightInches: 0, weightInPounds: 175)
         Player horcoff = new Player(firstName: 'Shawn', lastName: 'Horcoff', number: 10, heightFeet: 5, heightInches: 11, weightInPounds: 190)
         Player iginla = new Player(firstName: 'Jerome', lastName: 'Iginla', number: 12, heightFeet: 6, heightInches: 1, weightInPounds: 205)
         Player bertuzzi = new Player(firstName: 'Todd', lastName: 'Bertuzzi', number: 7, heightFeet: 6, heightInches: 2, weightInPounds: 215)
         
         wild.addToPlayers(koivu)
         wild.addToPlayers(burns)
         devils.addToPlayers(rolston)
         devils.addToPlayers(elias)
         oilers.addToPlayers(hemsky)
         oilers.addToPlayers(horcoff)
         flames.addToPlayers(iginla)
         flames.addToPlayers(bertuzzi)
         
         // Player stats and news
         koivu.addToGameStats(new PlayerStats(game: game1, goals: 1, assists: 2))
         koivu.addToGameStats(new PlayerStats(game: game3, goals: 0, assists: 2))
         burns.addToGameStats(new PlayerStats(game: game1, goals: 1, assists: 0))
         burns.addToGameStats(new PlayerStats(game: game3, goals: 0, assists: 1))
         rolston.addToGameStats(new PlayerStats(game: game1, goals: 2, assists: 1))
         rolston.addToGameStats(new PlayerStats(game: game4, goals: 1, assists: 0))
         elias.addToGameStats(new PlayerStats(game: game1, goals: 0, assists: 3))
         elias.addToGameStats(new PlayerStats(game: game4, goals: 2, assists: 2))
         hemsky.addToGameStats(new PlayerStats(game: game2, goals: 1, assists: 1))
         hemsky.addToGameStats(new PlayerStats(game: game3, goals: 1, assists: 4))
         horcoff.addToGameStats(new PlayerStats(game: game2, goals: 3, assists: 0))
         horcoff.addToGameStats(new PlayerStats(game: game3, goals: 1, assists: 1))
         iginla.addToGameStats(new PlayerStats(game: game1, goals: 2, assists: 2))
         iginla.addToGameStats(new PlayerStats(game: game4, goals: 2, assists: 1))
         bertuzzi.addToGameStats(new PlayerStats(game: game1, goals: 0, assists: 0))
         bertuzzi.addToGameStats(new PlayerStats(game: game4, goals: 1, assists: 0))
         
         koivu.addToNewsItems(new PlayerNews(newsDate: gameDate1, news: 'Great performance!!'))
         bertuzzi.addToNewsItems(new PlayerNews(newsDate: gameDate1, news: 'Says he is sorry for sucker punching another guy.'))
         
         // Save the Players to the Teams
         wild.save(flush:true)
         devils.save(flush:true)
         oilers.save(flush:true)
         flames.save(flush:true)
         
         // Add teams for player administration
         superUser.addToTeamsToAdminister(wild)
         superUser.addToTeamsToAdminister(devils)
         superUser.addToTeamsToAdminister(oilers)
         superUser.addToTeamsToAdminister(flames)
         playerAdmin1.addToTeamsToAdminister(wild)
         playerAdmin1.addToTeamsToAdminister(devils)
         playerAdmin2.addToTeamsToAdminister(oilers)
         playerAdmin2.addToTeamsToAdminister(flames)
         
         // Add a scouting reports and notes
         def koivuReport= new ScoutingReport(generalNotes: 'Scouting report for Mikko Koivu', ratingSkating: 7, ratingPuckControl: 8, ratingPhysicalPlay: 8, ratingSize: 8,
                     ratingHockeySense: 8, ratingIntensity: 8, ratingOffensivePlay: 8, ratingDefensivePlay: 9, player: koivu)
         def eliasReport= new ScoutingReport(generalNotes: 'Scouting report for Patrik Elias', ratingSkating: 7, ratingPuckControl: 8, ratingPhysicalPlay: 6, ratingSize: 7,
                 ratingHockeySense: 9, ratingIntensity: 7, ratingOffensivePlay: 9, ratingDefensivePlay: 9, player: elias)
         def iginlaReport= new ScoutingReport(generalNotes: 'Scouting report for Jerome Iginla', ratingSkating: 7, ratingPuckControl: 8, ratingPhysicalPlay: 9, ratingSize: 9,
                 ratingHockeySense: 9, ratingIntensity: 10, ratingOffensivePlay: 9, ratingDefensivePlay: 8, player: iginla)
         def hemskyReport= new ScoutingReport(generalNotes: 'Scouting report for Ales Hemsky', ratingSkating: 7, ratingPuckControl: 9, ratingPhysicalPlay: 5, ratingSize: 6,
                 ratingHockeySense: 10, ratingIntensity: 8, ratingOffensivePlay: 10, ratingDefensivePlay: 7, player: hemsky)
         def burnsReport= new ScoutingReport(generalNotes: 'Scouting report for Brent Burns', ratingSkating: 7, ratingPuckControl: 7, ratingPhysicalPlay: 9, ratingSize: 9,
                 ratingHockeySense: 8, ratingIntensity: 9, ratingOffensivePlay: 8, ratingDefensivePlay: 8, player: burns)
         def rolstonReport= new ScoutingReport(generalNotes: 'Scouting report for Brian Rolston', ratingSkating: 7, ratingPuckControl: 7, ratingPhysicalPlay: 8, ratingSize: 8,
                 ratingHockeySense: 8, ratingIntensity: 10, ratingOffensivePlay: 7, ratingDefensivePlay: 7, player: rolston)
         
         Date dateLogged = new GregorianCalendar(2009, GregorianCalendar.JANUARY, 24).time
         koivuReport.addToScoutingNotes(new ScoutingNotes(note: 'Good game!!', dateLogged: dateLogged))
         eliasReport.addToScoutingNotes(new ScoutingNotes(note: 'Elias is getting his legs back', dateLogged: dateLogged))
         iginlaReport.addToScoutingNotes(new ScoutingNotes(note: 'Struggling lately', dateLogged: dateLogged))
         hemskyReport.addToScoutingNotes(new ScoutingNotes(note: 'Needs to get his head in the game.', dateLogged: dateLogged))
         burnsReport.addToScoutingNotes(new ScoutingNotes(note: 'Solid defensive effort.', dateLogged: dateLogged))
         rolstonReport.addToScoutingNotes(new ScoutingNotes(note: 'Good fit in the NJ Devils system.', dateLogged: dateLogged))
         
         
         // Add players to scouting watch list
         scout1.addToScoutingReports(koivuReport)
         scout1.addToScoutingReports(eliasReport)
         
         scout2.addToScoutingReports(iginlaReport)
         scout2.addToScoutingReports(hemskyReport)
         
         superUser.addToScoutingReports(burnsReport)
         superUser.addToScoutingReports(rolstonReport)
         
         playerAdmin1.save(flush:true)
         playerAdmin2.save(flush:true)
         scout1.save(flush:true)
         scout2.save(flush:true)
         
         superUser.save(flush:true)
     }
} 