<html>
    <head>
    	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
        <title>
        	<g:layoutTitle default="Hockey Stats Manager" />
        </title>
        
        <g:javascript library="ext" />	
        
        <ext:stylesheet dir="resources/css" file="ext-all.css" />
        <ext:stylesheet dir="../../../css" file="hockeystats.css" />
                
        <%--
        <!-- Use YUI as the base, just because we can -->
        <ext:javascript dir="adapter/yui" file="yui-utilities.js" />
        <ext:javascript dir="adapter/yui" file="ext-yui-adapter.js" />
        
        --%>
        <%--
        <!-- How about JQuery -->
        <ext:javascript dir="adapter/jquery" file="jquery.js" />
        <ext:javascript dir="adapter/jquery" file="ext-jquery-adapter.js" />
        --%>
		
		<!-- Use Prototype as the base.  Grails uses it.  Why don't we!! -->
		<%-- 
        <ext:javascript dir="adapter/prototype" file="prototype.js" />
        <ext:javascript dir="adapter/prototype" file="scriptaculous.js?load=effects" />
        <ext:javascript dir="adapter/prototype" file="ext-prototype-adapter.js" />
        --%>
        
        <!-- Use Ext base -->
        <ext:javascript dir="adapter/ext" file="ext-base.js" />
        
        <!-- Load the debug version of the library.  This can replaced by minimized version in production -->
        <ext:javascript dir="." file="ext-all-debug.js" />
        
        <%-- Need the blank image for Ext Spacing.  Also set a var to the main content panel --%>
        <script type="text/javascript" charset="utf-8">
        	var HockeyStats = {
        		BASE_URL: '<g:createLinkTo dir="" file="" />',
        		LEAGUE_REST_URL: '<g:createLinkTo dir="rest/league" file=""/>',
        		TEAM_REST_URL: '<g:createLinkTo dir="rest/team" file=""/>',
        		PLAYER_REST_URL: '<g:createLinkTo dir="rest/player" file=""/>',
        		SCOUT_REPORT_REST_URL: '<g:createLinkTo dir="rest/scoutingReport" file=""/>',
        		LEAGUE_ADMIN_URL: '<g:createLink controller="leagueAdmin" />',
        		PLAYER_MGMT_URL: '<g:createLink controller="playerMgmt" />',
        		SCOUTING_URL: '<g:createLink controller="scouting" />',
        		Roles: {
            		leagueAdmin: false,
            		playerAdmin: false,
            		playerScout: false
            		
        		}
        	};
        	
			Ext.BLANK_IMAGE_URL = "${createLinkTo(dir:'js',file:'ext/2.2.1/resources/images/default/s.gif')}";
	
	    	// Create a handle to the main content region of the layout
	    	var contentPanelConfig = {
	    	    id: 'hockeystats-content-panel',
				region: 'center',
				xtype: 'panel',
				contentEl: 'content'		
	    	}; 
		</script>
		
		<%-- Initialize the Security Roles Config (Acegi plugin Taglib) --%>
        <g:ifAllGranted role="ROLE_LEAGUE_ADMIN">
        	<script type="text/javascript" charset="utf-8">
	        	HockeyStats.Roles.leagueAdmin = true;
			</script>
        </g:ifAllGranted>
        <g:ifAllGranted role="ROLE_PLAYER_ADMIN">
        	<script type="text/javascript" charset="utf-8">
        		HockeyStats.Roles.playerAdmin = true;
			</script>
        </g:ifAllGranted>
        <g:ifAllGranted role="ROLE_PLAYER_SCOUT">
        	<script type="text/javascript" charset="utf-8">
        		HockeyStats.Roles.playerScout = true;
			</script>
        </g:ifAllGranted>
        
         <!-- Add the Custom JS Code -->
        <ext:javascript dir="../../hockeystats" file="Menubar.js" />
        
        <g:layoutHead />
    </head>
    
    <body>
    	<NOSCRIPT>JavaScript not supported.  Provide a link to an alternative accessible site.</NOSCRIPT> 

		<div id="layout-doc">
		<div id="header">
			<div id="header-logo">
				<table>
					<tbody>
						<tr>
							<td><img src="${createLinkTo(dir:'images/hockeystats',file:'logo.jpg')}"></img></td>
							<td>Hockey Statistics Manager</td>
						</tr>
					</tbody>
				</table>
			</div>
			<div id="header-menu">
				<!--<noscript>-->
					<a href="${createLink(controller:'leagueAdmin')}">League Administration</a>|
					<a href="${createLink(controller:'playerMgmt')}">Player Administration</a>|
					<a href="${createLink(controller:'scouting')}">Scouting Reports</a>
				<!--</noscript>--></div>
		</div>
		
		<div id="content">
	    	<%-- Continue with laying out the body for the page --%>
	    	<g:layoutBody />
    	</div>
    	
    	<div id="footer">
    		<noscript>Copyright 2009 - Torey Lomenda</noscript></div>
    	</div>
    </body>
    
    <script type="text/javascript">

    	Ext.onReady(function() {
        	// Let's initialize QuickTips for validation errors, etc.
        	Ext.QuickTips.init();
        	
		 	// Hide the JavaScript Not Enabled
			// Ext.get("noJavaScriptDiv").hide();
		
	    	// Create the main layout for the page. 
	    	var viewport = new Ext.Viewport({
				layout: 'border',
				renderTo:  'layout-doc',
				items: [
				    {
					    region: 'north',
					    xtype: 'panel',
					    height: 122,
					    contentEl: 'header'
				    },
				    contentPanelConfig,
				    {
					    region: 'south',
					    xtype: 'panel',
					    height: 30,
					    contentEl: 'footer',
					    items: [{applyTo: 'footer', autoHeight: true, cls: 'footer-text', html: 'Copyright 2009 - Torey Lomenda', border: false}] // Replace the footer text (after step 1)
				    }
				]	
	        });
    	});

    	// Add a menubar
        var menubar = new hockeystats.menu.Menubar()
	</script>	
</html>