<html>
	<head>
		<meta name="layout" content="main-extjs" />
		<title>Hockey Stats Manager - Scouting Reports</title>
		
		<script type="text/javascript" charset="utf-8">
			if (Ext.type(contentPanelConfig)) {
				Ext.apply(contentPanelConfig, {
					layout: 'border',
					items: [
						{
							region: 'west',
							xtype: 'panel',
							contentEl: 'playerWatchListLayoutPanel',
							title: 'Player Watch List',
							split: true,
							collapsible: true,
							collapseMode: 'mini',
							width: 250,
							maxSize: 300,
							minSize: 100,
							items: [
								// Step 4 {xtype: 'hockeystats.panel.PlayerWatchListPanel', renderTo: 'playerWatchListTreePanel'}
							]
					    },
					    {
						    region: 'center',
						    xtype: 'panel',
						    autoScroll: true,
						    contentEl: 'scoutingReportsLayoutPanel',
						    items: [
						           // Step 5 {xtype: 'hockeystats.panel.ScoutingReportInfoPanel', renderTo: 'scoutingReportInfoPanel'}
							]
					    },
					    {
						    region: 'east',
						    xtype: 'panel', 
						    width: 300,
						    contentEl: 'playerSearchLayoutPanel',
						    items: [
						          // Step 7  {xtype: 'hockeystats.panel.PlayerSearchPanel', renderTo: 'playerSearchPanel'}
							]
					    }
					],

				    // Step 6
					// Register listeners once this component is rendered
					//listeners: {
					//	render:	{
					//		fn: function(contentPanel) {
					//			// The reporting info panel needs to listen to the Tree panel selection to update its state.
					//			// Do this through an adapter.
					//			hockeystats.events.ScoutingReportAdapter.registerLoadReportListener(contentPanel);
					//		},
					//		single: true
					//	}
					//},

					// Let us add some custom functions as convenient item accessors (used to register listeners after the component is rendered)
					getPlayerWatchListPanel: function() {
						// Get the tree panel from the content panel.
						var westPanel = this.items.get(0);					
						return westPanel.items.get(0); // Based on the layout, this is the panel we want
					},

					getScoutingReportInfoPanel: function() {
						// Get the tree panel from the content panel.
						var centerPanel = this.items.get(1);					
						return centerPanel.items.get(0); // Based on the layout, this is the panel we want
					}
				});
			}
		</script>
		
	</head>
	
	<!-- This will be all Ext JS baby -->
	<body>
		<noscript>
			<a href="${createLink(controller: 'scoutingReport', action:'list')}">Alternative site for Scouting Reports</a>
		</noscript>
		<div id="playerWatchListLayoutPanel">	
			<div id="playerWatchListTreePanel">
				Player Watch List
			</div>
		</div>
		<div id="scoutingReportsLayoutPanel">
			<div id="scoutingReportInfoPanel">
				Scouting Report
			</div>
				
		</div>
		<div id="playerSearchLayoutPanel">
			<div id="playerSearchPanel">
				Player Search
			</div>
		</div>
	</body>
</html>