Ext.namespace('hockeystats.menu');

// Define the Menubar
hockeystats.menu.Menubar = function(config){
    // If a config is passed in, use it.  Otherwise create the default config
    var menuConfig = config ? config : {};
    
    // Update the content of the header-menu
    Ext.get('header-menu').update('');
    
    Ext.apply(menuConfig, 
    {
        renderTo: 'header-menu', // See main-extjs.gsp for Layout
        
        // width: Ext.get('header-menu').getSize().width - 5,
        items: [
        {
            xtype: 'tbbutton',
            text: 'Home',
            handler: function(){
                window.location.replace(HockeyStats.BASE_URL);
            }
        }, 
        {
            xtype: 'tbseparator'
        }, 
        {
            xtype: 'tbbutton',
            text: 'Hockey Stats',
            menu: [
            {
                text: 'League Administration',
                disabled: !HockeyStats.Roles.leagueAdmin,
                handler: function(){
                    window.location.replace(HockeyStats.LEAGUE_ADMIN_URL);
                }
            }, 
            {
                text: 'Player Management',
                disabled: !HockeyStats.Roles.playerAdmin,
                handler: function(){
                    window.location.replace(HockeyStats.PLAYER_MGMT_URL);
                }
            }, 
            {
                text: 'Scouting Reports',
                disabled: !HockeyStats.Roles.playerScout,
                handler: function(){
                    window.location.replace(HockeyStats.SCOUTING_URL);
                }
            }]
        }, 
        {
            xtype: 'tbfill'
        }, 
        {
            xtype: 'tbbutton',
            text: 'Help',
            menu: [
            {
                text: 'About',
                handler: function(){
                    Ext.MessageBox.alert("About Hockey Stats", "Hockey Stats 0.1.  This is a Demo for Javascript on Grails!!");
                }
            }]
        }]
    });
    
    // Call the superclasses constructor
    hockeystats.menu.Menubar.superclass.constructor.call(this, menuConfig);
}

// Extend Ext's Component
Ext.extend(hockeystats.menu.Menubar, Ext.Toolbar, { // Nothing to extend or override at this point
});

// Register the component with Ext JS.  Registering with Ext's Component manager allows the component to 
// be lazily instantiated by Ext.
Ext.reg('hockeystats.menu.Menubar', hockeystats.menu.Menubar);
