/**
 * This Event Adapter is used to change the state of the ScoutingReportInfoPanel when a player is selected from the PlayerWatchListPanel
 * @author tlomenda
 */

Ext.namespace('hockeystats.events')

hockeystats.events.ScoutingReportAdapter = function() {
	
	return {
		/**
		 * This is used to register a listener when a node is clicked on the player watch list to load the scouting report into the UI.
		 */
		registerLoadReportListener: function(contentPanel) {
			var playerWatchListPanel = contentPanel.getPlayerWatchListPanel();
			var scoutingReportInfoPanel = contentPanel.getScoutingReportInfoPanel();
			
			// Register the listener
			playerWatchListPanel.on('click', function(node, event) {
				this.updateInfo(node.id);
			}, scoutingReportInfoPanel);
			
		}
	}
}();
