YAHOO.namespace("hockeystats.form.LeagueForm");

YAHOO.hockeystats.form.LeagueForm = function() {

    function parseJSON(json) {
        var object = YAHOO.lang.JSON.parse(json);
        var records = [];
        
        if (!YAHOO.lang.isUndefined(object.leagues)) {
            leagues = object.leagues;
            for (var i = 0; i < leagues.length; i++) {
                var league = leagues[i];
                var record = 
                    {
                        id: league.id,
                        name: league.name,
                        description: league.description,
                        sinceDate: league.sinceDate
                    };
                
                records.push(record);
            }
        }
        
        return records;
    }
    
    return {
        initForm: function() {
            this.initCombo();
            this.initButtons();
            
            YAHOO.util.Event.addListener("league-submit", "click", function() {
                // You can put some validation here.  Ext JS builds the validators right into the TriggerField (input) components
                
                var callback = {
                    success: function(o) {
                    
                        alert("League was saved");
                        
                        // Re-init the combo 
                        YAHOO.util.Dom.get('league-combo').innerHTML = '';
                        YAHOO.hockeystats.form.LeagueForm.initCombo();
                        
                        
                    },
                    
                    failure: function(o) {
                        alert("There was a problem!!");
                    }
                };
                
                var form = YAHOO.util.Dom.get('league-form');
                YAHOO.util.Connect.setForm(form);
                
                // Perform the transaction
                var transaction = YAHOO.util.Connect.asyncRequest('POST', HockeyStats.LEAGUE_REST_URL, callback);
                
            });
        },
        
        initCombo: function() {
        
            var callback = {
                success: function(o) {
                    // Parse Json into records for the combo
                    var records = parseJSON(o.responseText);
                    
                    var items = [{
                        text: "[Create New League]",
                        onclick: {
                            fn: function() {
                                // Set the label for the split button
                                splitButton.set("label", this.cfg.getProperty("text"));
                                
                                YAHOO.util.Dom.get('league-name').value = '[New]';
                                YAHOO.util.Dom.get('league-description').value = '';
                                YAHOO.util.Dom.get('sinceDate').value = '';
                                YAHOO.util.Dom.get('league-id').value = '';
                            }
                        }
                    }];
                    
                    // Push to items
                    for (i = 0; i < records.length; i++) {
                        var record = records[i];
                        var item = {
                            text: record.name,
                            record: record,
                            onclick: {
                                fn: function() {
                                    // Set the label for the split button
                                    splitButton.set("label", this.cfg.getProperty("text"));
                                    
                                    // We know that the first item was for a new league.  subtract one to get corresponding record
                                    var record = records[this.index - 1];
                                    YAHOO.util.Dom.get('league-name').value = record.name;
                                    YAHOO.util.Dom.get('league-description').value = record.description;
                                    YAHOO.util.Dom.get('sinceDate').value = record.sinceDate;
                                    YAHOO.util.Dom.get('league-id').value = record.id;
                                }
                            }
                        };
                        
                        // Attach the record to the item
                        items.push(item);
                    }
                    
                    // Generate the button
                    var splitButton = new YAHOO.widget.Button({
                        type: 'split',
                        label: 'Choose a League',
                        name: 'league-combo',
                        menu: items,
                        container: 'league-droplist'
                    });
                },
                
                failure: function(o) {
                    alert('There is an issue!!')
                }
            };
            
            var jsonRequest = YAHOO.util.Connect.asyncRequest('GET', HockeyStats.LEAGUE_REST_URL, callback, null);
        },
        
        initButtons: function() {
            var submitButton = new YAHOO.widget.Button("league-submit", {
                disabled: false
            });
        }
    }
}();
